// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function util_get_current_webiste_domain(url=''){
    let current_url = url;
    if(current_url){
        current_url = current_url.replace('https://','');
        let current_url_arr = current_url.split('/');
        return current_url_arr[0];
    }
    return 'www.amazon.com';
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.rawData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_getasin(url = ''){
    let _shangjia_id_str = url;
    //
    if(_shangjia_id_str.indexOf('?')!=-1){
        let _shangjia_id_str_list = _shangjia_id_str.split('?');
        _shangjia_id_str = _shangjia_id_str_list[0];
    }
    //
    let _shangjia_id_arr = _shangjia_id_str.split('/dp/');
    _shangjia_id_str = _shangjia_id_arr[1];
    if(_shangjia_id_str.indexOf('/')!=-1){
        let _shangjia_id_str_arr2 = _shangjia_id_str.split('/');
        _shangjia_id_str = _shangjia_id_str_arr2[0];
    }
    let asin = _shangjia_id_str;
    return asin;
}

function util_getFileExtension(filename = '') {
    return filename.slice(filename.lastIndexOf('.') + 1);
}

function pause_s_time(){
    chrome.storage.local.get(null, function(items) {
        //
        chrome.storage.local.set({pause_s_time: Date.now()});
    });
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

function pause_setting_desc_switch(callback){
    chrome.storage.local.get(null, function(items) {
        console.log('pause_setting_desc_switch setting');
        //
        let prefix = 'pause_setting_desc';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_setting_desc: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_setting_desc: 0}, callback);
            }else{
                chrome.storage.local.set({pause_setting_desc: 1}, callback);
            }
        }
    });
}

function pause_list_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_list';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_list: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_list: 0}, callback);
            }else{
                chrome.storage.local.set({pause_list: 1}, callback);
            }
        }
    });
}

function field_name_set(field_name = '', callback){
    chrome.storage.local.set({field_name: field_name}, callback);
}
// Function to convert an image to a Blob
async function imageToBlob(imageUrl) {
  try {
    // Fetch the image as an array buffer
    const response = await fetch(imageUrl);
    const arrayBuffer = await response.arrayBuffer();

    // Create a Blob from the array buffer
    const blob = new Blob([arrayBuffer], { type: response.headers.get("content-type") });

    return blob;
  } catch (error) {
    console.error("Error converting image to Blob:", error);
    return null;
  }
}

// Usage example:
/*const imageUrl = "https://img.kwcdn.com/product/Fancyalgo/VirtualModelMatting/8af63f79afdd388711b1c34289c15cda.jpg?imageView2/2/w/800/q/70/format/webp";
imageToBlob(imageUrl)
  .then(blob => {
    if (blob) {
      // Do something with the Blob, such as uploading it or displaying it
        console.log('aaaa');
        console.log(blob);
    } else {
        console.log("Failed to convert image to Blob.");
    }
  });*/

function urlToBase64(url, callback) {
  const xhr = new XMLHttpRequest();
  xhr.onload = function() {
    const reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result);
    };
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}

// 使用示例
/*const imageUrl = 'https://example.com/image.jpg'; // 替换为你自己的图片URL
urlToBase64(imageUrl, function(base64String) {
  console.log(base64String); // 这里是Base64编码的图片字符串
});*/
//
function storage_shangjia_item_url_set(_shangjia_info={},local_num=1, callback){
    //
    if(typeof _shangjia_info['shangjia_item_url'] == 'undefined'){
        return;
    }
    if(_shangjia_info['shangjia_item_url'].indexOf('undefined') != -1){
        return;
    }
    if(_shangjia_info['shangjia_item_url'].indexOf('/dp/') == -1){
        return;
    }
    //
    let _shangjia_item_url = _shangjia_info['shangjia_item_url'];
    let _shangjia_item_url_arr = _shangjia_item_url.split('?');
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_item_url_arr[0]);
    //
    chrome.storage.local.get(null, function(items) {
        let total_add_shangjia_num = 0;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
            }
        }
        total_add_shangjia_num = total_add_shangjia_num + local_num;
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                //'_shangjia_name': _shangjia_info['_shangjia_name'],
                //'_shangjia_catalog_1': '',
                //'_shangjia_catalog_2': '',
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['shangjia_item_url'],
                '_is_request':0,

                //'_shangjia_img': _shangjia_info['_shangjia_img'],
                //'_shangjia_images': '',
                //'_shangjia_img_blob': '',
                //'_shangjia_price': _shangjia_info['_shangjia_price'],
               // '_shangjia_old_price': _shangjia_info['_shangjia_old_price'],
                //'_shangjia_review_score': _shangjia_info['_shangjia_review_score'],
                //'_shangjia_reivew_num': _shangjia_info['_shangjia_reivew_num'],
                //'_shangjia_sold': _shangjia_info['_shangjia_sold'],
                //'_shangjia_desc':'',

                '_shangjia_store_name': '',
                '_shangjia_store_url': '',
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_score': '',
                //
                '_shangjia_goodsId':'', //sku
                '_shangjia_variants_skus': [], //数组
                '_shangjia_goodsName': '',
                '_shangjia_goodsProperty':'',//description,deschtml
                '_product_intro__sizeguide':'',
                '_product_about_this_item':'',
                '_shangjia_desc':'',
                '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
                '_shangjia_hdThumbUrl': '',//主图
                '_shangjia_gallery':[], //图片列表
                '_shangjia_productDetailFlatList':[],//details imgs
                '_shangjia_category':'',//brumb
                '_shangjia_VideoUrl':'', //video
                //
                'num':(total_add_shangjia_num+1)
            };

            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}
//
//
function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={},local_num=1, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        let total_add_shangjia_num = 0;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
            }
        }
        total_add_shangjia_num = total_add_shangjia_num + local_num;
        //
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                //'_shangjia_name': _shangjia_info['_shangjia_name'],
                //'_shangjia_catalog_1': '',
                //'_shangjia_catalog_2': '',
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['_shangjia_a_link'],
                '_is_request':0,

                //'_shangjia_img': _shangjia_info['_shangjia_img'],
                //'_shangjia_images': '',
                //'_shangjia_img_blob': '',
                //'_shangjia_price': _shangjia_info['_shangjia_price'],
               // '_shangjia_old_price': _shangjia_info['_shangjia_old_price'],
                //'_shangjia_review_score': _shangjia_info['_shangjia_review_score'],
                //'_shangjia_reivew_num': _shangjia_info['_shangjia_reivew_num'],
                //'_shangjia_sold': _shangjia_info['_shangjia_sold'],
                //'_shangjia_desc':'',

                '_shangjia_store_name': '',
                '_shangjia_store_url': '',
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_score': '',
                //
                '_shangjia_goodsId':'', //sku
                '_shangjia_variants_skus': [], //数组
                '_shangjia_goodsName': '',
                '_shangjia_goodsProperty':'',//description,deschtml
                '_product_intro__sizeguide':'',
                '_product_about_this_item':'',
                '_shangjia_desc':'',
                '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
                '_shangjia_hdThumbUrl': '',//主图
                '_shangjia_gallery':[], //图片列表
                '_shangjia_productDetailFlatList':[],//details imgs
                '_shangjia_category':'',//brumb
                '_shangjia_VideoUrl':'', //video
                'num':(total_add_shangjia_num+1)
                //
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function util_timeConsumingFunction(seconds) {
  // 将秒数转换为毫秒
  const milliseconds = seconds * 1000;

  // 模拟耗时操作，例如循环计算
  const startTime = new Date().getTime();
  while (new Date().getTime() - startTime < milliseconds) {
    // 一些计算
  }
}

function shangjia_get_subskus(_dom,_shangjia_goodsId='',
                              specs_key1_name='',
                              _specs_key1_value = '',
                              specs_key2_name=''){
    //
    let _shangjia_variants_skus_cucao = [];
    _dom.find("#variation_size_name select[name='dropdown_selected_size_name'] option").each(function (){
        //
        let _option_val = $(this).val();
        if(_option_val != '-1'){
            //
            let specs_key2_value = $(this).text();
            specs_key2_value = specs_key2_value.trim();
            //
            let _subsku = _shangjia_goodsId+'-'+_specs_key1_value+'-'+specs_key2_value;
            //
            let _product_price = _dom.find('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
            let _product_old_price = _dom.find('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
            if(_product_price){
                _product_price = _product_price.trim();
                _product_price = _product_price.replace('$','');
            }
            if(_product_old_price){
                _product_old_price = _product_old_price.trim();
                _product_old_price = _product_old_price.replace('$','');
            }
            //
            let _stockQuantity = '';
            let _quantity_text = _dom.find('#availabilityInsideBuyBox_feature_div:eq(0) #availability span').text();
            _quantity_text = _quantity_text.trim();
            let _quantity_text_lower = _quantity_text.toLowerCase();
            if(_quantity_text_lower == 'in stock' || _quantity_text_lower.indexOf('in stock') !=-1
                            || _quantity_text == '现在有货。'
                            || _quantity_text_lower.indexOf('ships') !=-1
                            || _quantity_text_lower.indexOf('ship') !=-1
            ){
                //
                //
            }else{
                //Only 8 left in stock - order soon.
                // 库存中仅剩 1 件 - 欲购从速。
                _quantity_text = _quantity_text.replace('Only','').replace('left in stock - order soon.','')
                            .replace('库存中仅剩','').replace('件 - 欲购从速。','').replace('left in stock (more on the way).','');
                _quantity_text = _quantity_text.trim();
                //
                if(_quantity_text_lower.indexOf('out of stock') !=-1){
                    _stockQuantity = 0;
                }
                //
            }
            //
            _shangjia_variants_skus_cucao.push({
                'subsku': _subsku, //自定义变体带属性SKU
                'normalPriceStr': _product_price, //特价
                'normalLinePriceStr': _product_old_price, //原价
                'img':'',
                'gallery_imgs':[],
                'video_url':'',
                'specs_key1_name':_specs_key1_value!=''?specs_key1_name:'',
                'specs_key1_value':_specs_key1_value,
                'specs_key2_name':specs_key2_name,
                'specs_key2_value':specs_key2_value,
                'specs_key3_name':'',
                'specs_key3_value':'',
                'specs_key4_name':'',
                'specs_key4_value':'',
                'stockQuantity': _stockQuantity,
                'skuId': '' //原变体sku
            });
            //
        }
    });
    _dom.find("#variation_size_name ul li").each(function (){
        //
        if(1){
            //
            let specs_key2_value =  $(this).find('.twisterTextDiv').text();
            specs_key2_value = specs_key2_value.trim();
            //
            let _subsku = _shangjia_goodsId+'-'+_specs_key1_value+'-'+specs_key2_value;
            //
            let _product_price = _dom.find('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
            let _product_old_price = _dom.find('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
            if(_product_price){
                _product_price = _product_price.trim();
                _product_price = _product_price.replace('$','');
            }
            if(_product_old_price){
                _product_old_price = _product_old_price.trim();
                _product_old_price = _product_old_price.replace('$','');
            }
            //
            let _stockQuantity = '';
            let _quantity_text = _dom.find('#availabilityInsideBuyBox_feature_div:eq(0) #availability span').text();
            _quantity_text = _quantity_text.trim();
            let _quantity_text_lower = _quantity_text.toLowerCase();
            if(_quantity_text_lower == 'in stock' || _quantity_text_lower.indexOf('in stock') !=-1
                            || _quantity_text == '现在有货。'
                            || _quantity_text_lower.indexOf('ships') !=-1
                            || _quantity_text_lower.indexOf('ship') !=-1
            ){
                //
                //
            }else{
                //Only 8 left in stock - order soon.
                // 库存中仅剩 1 件 - 欲购从速。
                _quantity_text = _quantity_text.replace('Only','').replace('left in stock - order soon.','')
                            .replace('库存中仅剩','').replace('件 - 欲购从速。','').replace('left in stock (more on the way).','');
                _quantity_text = _quantity_text.trim();
                //
                if(_quantity_text_lower.indexOf('out of stock') !=-1){
                    _stockQuantity = 0;
                }
                //
            }
            //
            _shangjia_variants_skus_cucao.push({
                'subsku': _subsku, //自定义变体带属性SKU
                'normalPriceStr': _product_price, //特价
                'normalLinePriceStr': _product_old_price, //原价
                'img':'',
                'gallery_imgs':[],
                'video_url':'',
                'specs_key1_name':_specs_key1_value!=''?specs_key1_name:'',
                'specs_key1_value':_specs_key1_value,
                'specs_key2_name':specs_key2_name,
                'specs_key2_value':specs_key2_value,
                'specs_key3_name':'',
                'specs_key3_value':'',
                'specs_key4_name':'',
                'specs_key4_value':'',
                'stockQuantity': _stockQuantity,
                'skuId': '' //原变体sku
            });
            //
        }
    });
    //console.log('_shangjia_variants_skus_cucao');
    //console.log(_shangjia_variants_skus_cucao);
    return _shangjia_variants_skus_cucao;
    //
}

function util_get_json(url= ''){
    console.log('url:'+url);
    let r_data = '';
    $.ajax({
            url:url,
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:false,
            dataType: 'json',
            crossDomain: true,
            cache: false,
            success: function(data) {
                console.log('util_get_json:'+url);
                console.log(data);
                r_data =  data;
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('util_get_json遇到反爬');
                console.log( jqXHR, textStatus, errorThrown );
            }
        });
    return r_data;
}

function util_get_ajax_html(url= ''){
    console.log('util_get_ajax_html url:'+url);
    let r_data = '';
    $.ajax({
            url:url,
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:false,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                r_data =  data;
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('util_get_ajax_html遇到反爬');
                console.log( jqXHR, textStatus, errorThrown );
            }
        });
    return r_data;
}

function util_amz_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('ImageBlockATF') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_amz_get_product_lunbo_imgs(_dom){
   let _leftColHtml =  _dom.find('#leftCol').html();
   let _amz_script = util_amz_getscript_pageData_content(_leftColHtml);
   //console.log('_amz_script');
   //console.log(_amz_script);
   let _amz_script_tmp_arr = _amz_script.split("var data =");
   let _amz_script_tmp_str = _amz_script_tmp_arr[1];
   let _amz_script_tmp_str_arr = _amz_script_tmp_str.split('A.trigger');
   let _amz_script_imgs_str = _amz_script_tmp_str_arr[0];
   _amz_script_imgs_str = _amz_script_imgs_str.trim();
   _amz_script_imgs_str = _amz_script_imgs_str.slice(0,-1);
   //
    let _amz_script_imgs_tmp_arr  = _amz_script_imgs_str.split("'colorImages':");
    //
    let _amz_script_imgs_temp2 = _amz_script_imgs_tmp_arr[1];
    let _amz_script_imgs_temp2_str = _amz_script_imgs_temp2.split("'colorToAsin'");
    let _amz_script_imgs = _amz_script_imgs_temp2_str[0];
    _amz_script_imgs = _amz_script_imgs.trim();
    _amz_script_imgs = _amz_script_imgs.slice(0,-1);
    _amz_script_imgs = _amz_script_imgs.replace("{ 'initial':","");
    _amz_script_imgs = _amz_script_imgs.slice(0,-1);
    let _amz_script_imgs_arr = JSON.parse(_amz_script_imgs);
    console.log('_amz_script_imgs_arr');
    console.log(_amz_script_imgs_arr);
    //
    let _images = [];
    let _sort = 1;
    for(let i=0;i<_amz_script_imgs_arr.length;i++){
        //let _img = _amz_script_imgs_arr[i]['hiRes'];
        let _img = _amz_script_imgs_arr[i]['large'];
        if(_img){
            _images.push(_img);
            _sort++;
        }
    }
    return _images;
    //
}

function util_amz_get_product_video(html = ''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('awaConfig') !=-1 && scriptContent.indexOf('videoUrl') !=-1){
                //
                let scriptContent_JSON = JSON.parse(scriptContent);
                console.log('scriptContent_JSON');
                console.log(scriptContent_JSON);
                return scriptContent_JSON['videoUrl'];
                //
            }
        }
    }
    //triggerVideoAjax
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('triggerVideoAjax') !=-1){
                //
                let scriptContentArr = scriptContent.split('triggerVideoAjax');
                if(scriptContentArr.length > 1){
                    let _scriptContent = scriptContentArr[1];
                    let _scriptContentArr = _scriptContent.split("A.$.parseJSON(");
                    let _scriptContent2 = _scriptContentArr[1];
                    let _scriptContent2Arr = _scriptContent2.split("A.trigger");
                    let _scriptContent3 = _scriptContent2Arr[0];
                    _scriptContent3 = _scriptContent3.substring(1);
                    _scriptContent3 = _scriptContent3.slice(0,-4);
                    _scriptContent3 = _scriptContent3.replaceAll("\'",'');
                    _scriptContent3 = _scriptContent3.replaceAll("\\",'');
                    console.log('_scriptContent3');
                    console.log(_scriptContent3);
                    _scriptContent3 = _scriptContent3.trim();
                    let scriptContent_JSON = JSON.parse(_scriptContent3);
                    let videos = scriptContent_JSON['videos'];
                    for(let _v_key in videos){
                        let _video_url = videos[_v_key]['url'];
                        if(util_getFileExtension(_video_url) == 'mp4'){
                            return _video_url;
                        }
                    }
                }
                //
            }
        }
    }
    //
    return '';
}

function shangjia_get_subskus_ajax( current_domain,
                                    specs_key1_name='',
                                    specs_key2_name='',
                                    relation_color_asin='',
                                   _size_arr=[]){
    //
    let _shangjia_variants_skus_cucao = [];
    let subsku_url = 'https://'+current_domain+'/name/dp/'+relation_color_asin+'/?psc=1';
    let _html_data = util_get_ajax_html(subsku_url);
    if(_html_data){
        console.log('shangjia_get_subskus_ajax a1');
        let _html_dom = $(_html_data);
        let _specs_key1_value = _html_dom.find('#variation_color_name span.selection').text();
        _specs_key1_value = _specs_key1_value.trim();
        //select形式的
        if(typeof _specs_key1_value == 'undefined' || _specs_key1_value == ''){
            _specs_key1_value = _html_dom.find('#dropdown_selected_color_name').text();
            if(_specs_key1_value){
                _specs_key1_value = _specs_key1_value.trim();
            }
        }
        //
        let _original_price = '';
        let _discount_price = '';
        let _stockQuantity = '';
        let _color_image = '';
        _color_image = _html_dom.find('#variation_color_name .swatchSelect').find('img').attr('src');
        //
        let _product_price = _html_dom.find('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
        let _product_old_price = _html_dom.find('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
        if(_product_price){
            _product_price = _product_price.trim();
            _product_price = _product_price.replace('$','');
        }
        _discount_price = _product_price;
        if(_product_old_price){
            _product_old_price = _product_old_price.trim();
            _product_old_price = _product_old_price.replace('$','');
        }
        _original_price = _product_old_price;
        //
        console.log('shangjia_get_subskus_ajax a2');
        let _shangjia_gallery = util_amz_get_product_lunbo_imgs(_html_dom);
        let _img = _shangjia_gallery[0];
        //
        let _video_url = util_amz_get_product_video(_html_data);
        //
        ///let _quantity_ajax_url = "https://www.amazon.com/gp/product/ajax?&asin="+need_item['_asin']+"&quantity=1&exclusiveMerchantId=A39YJHD2QGAV1F&merchantId=A39YJHD2QGAV1F&clientId=retailwebsite&deviceType=web&showFeatures=deliveryBlock&ie=UTF8&experienceId=deliveryBlockQuantityRefreshAjaxExperience";
        let _quantity_text = _html_dom.find('#availabilityInsideBuyBox_feature_div:eq(0) #availability span').text();
        _quantity_text = _quantity_text.trim();
        let _quantity_text_lower = _quantity_text.toLowerCase();
        if(_quantity_text_lower == 'in stock' || _quantity_text_lower.indexOf('in stock') !=-1
                        || _quantity_text == '现在有货。'
                        || _quantity_text_lower.indexOf('ships') !=-1
                        || _quantity_text_lower.indexOf('ship') !=-1
        ){
            //
            //
        }else{
            //Only 8 left in stock - order soon.
            // 库存中仅剩 1 件 - 欲购从速。
            _quantity_text = _quantity_text.replace('Only','').replace('left in stock - order soon.','')
                        .replace('库存中仅剩','').replace('件 - 欲购从速。','').replace('left in stock (more on the way).','');
            _quantity_text = _quantity_text.trim();
            //
            if(_quantity_text_lower.indexOf('out of stock') !=-1){
                _stockQuantity = 0;
            }
            //
        }
        //
        if(_size_arr.length>0){
            console.log('shangjia_get_subskus_ajax a3');
           for(let _s=0;_s<_size_arr.length;_s++){
                //
                let specs_key2_value = _size_arr[_s];
                //
                let _subsku = relation_color_asin+'-'+_specs_key1_value+'-'+specs_key2_value;
                _shangjia_variants_skus_cucao.push({
                        'subsku': _subsku, //自定义变体带属性SKU
                        'normalPriceStr': _discount_price, //特价
                        'normalLinePriceStr': _original_price, //原价
                        'color_image':_color_image,
                        'img':_img,
                        'gallery_imgs':_shangjia_gallery,
                        'video_url':_video_url,
                        'specs_key1_name':specs_key1_name,
                        'specs_key1_value':_specs_key1_value,
                        'specs_key2_name':specs_key2_name,
                        'specs_key2_value':specs_key2_value,
                        'specs_key3_name':'',
                        'specs_key3_value':'',
                        'specs_key4_name':'',
                        'specs_key4_value':'',
                        'stockQuantity': _stockQuantity,
                        'skuId': '' //原变体sku
                });
            }
        }else{
            //
            let _subsku = relation_color_asin+'-'+_specs_key1_value;

            _shangjia_variants_skus_cucao.push({
                'subsku': _subsku, //自定义变体带属性SKU
                'normalPriceStr': _discount_price, //特价
                'normalLinePriceStr': _original_price, //原价
                'color_image':_color_image,
                'img':_img,
                'gallery_imgs':_shangjia_gallery,
                'video_url':_video_url,
                'specs_key1_name':specs_key1_name,
                'specs_key1_value':_specs_key1_value,
                'specs_key2_name':specs_key2_name,
                'specs_key2_value':'',
                'specs_key3_name':'',
                'specs_key3_value':'',
                'specs_key4_name':'',
                'specs_key4_value':'',
                'stockQuantity': _stockQuantity,
                'skuId': '' //原变体sku
            });
            //
        }
    }else{
        console.log('shangjia_get_subskus_ajax a3');
    }
    console.log('_shangjia_variants_skus_cucao');
    console.log(_shangjia_variants_skus_cucao);
    return _shangjia_variants_skus_cucao;
    //
}


function util_getscript_goodsDetailV3SsrData_content_old(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('goodsDetailV3SsrData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_getscript_goodsDetailV3SsrData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.gbRawData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function request_shangjia_about_contact_and_basic_info_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //
        //need_item['_shangjia_about_contact_and_basic_info_link'] = 'https://www.temu.com/goods.html?_bg_fs=1&goods_id=601099513966458';
        if(need_item['_shangjia_about_contact_and_basic_info_link'] && need_item['_shangjia_about_contact_and_basic_info_link'].indexOf('/dp/') ==-1){
            need_item['_e_time'] = Date.now();
            need_item['_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
            });
            return;
        }
        console.log('request_shangjia_about_contact_and_basic_info_ajax aaa');
        console.log(need_item['_shangjia_about_contact_and_basic_info_link']);
        //
        let pause_setting_desc = 1; //关闭
        if(!items.hasOwnProperty('pause_setting_desc') || items['pause_setting_desc'] == 0){
            pause_setting_desc = 0; //开启
        }
        //
        $.ajax({
            url:need_item['_shangjia_about_contact_and_basic_info_link'],
            timeout : 50000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                console.log('data');
                //console.log(data);
               let _dom = $(data);
               //
               let _mainContent = _dom.find('.mainContent').text();
               let _baseContent = _dom.find('.baseContent').text();
               let _checkContent = _mainContent;
               if(_baseContent){
                   _checkContent += _baseContent;
               }
               if(false && util_checkFanpa(_checkContent)){
                   console.log('util_checkFanpa a1');
                   //
                    need_item['_is_request'] = 0;
                    need_item['_error'] = '遇到亚马逊反爬,请开启或者更换代理或者暂停采集，稍后再采集!';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                            //

                            //
                    });
                    pause_s_time();
                    sendPopTips("遇到亚马逊反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
               }else{
                   //console.log('util_checkFanpa a2');
                   let current_domain = util_get_current_webiste_domain(need_item['_shangjia_about_contact_and_basic_info_link']);
                   //
                   let _shangjia_goodsName = _dom.find('#productTitle').text();
                   if(_shangjia_goodsName){
                       //
                        if(1) {
                            if (1) {
                                //
                                let _shangjia_goodsId = util_getasin(need_item['_shangjia_about_contact_and_basic_info_link']);
                                need_item['_shangjia_goodsId'] = _shangjia_goodsId;
                                //
                                need_item['_product_url'] = need_item['_shangjia_about_contact_and_basic_info_link'];
                                //
                                _shangjia_goodsName = _shangjia_goodsName.trim();
                                need_item['_shangjia_goodsName'] = _shangjia_goodsName;
                                //
                                let _product_price = _dom.find('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
                                let _product_old_price = _dom.find('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
                                if(_product_price){
                                    _product_price = _product_price.trim();
                                    _product_price = _product_price.replace('$','');
                                }
                                if(_product_old_price){
                                    _product_old_price = _product_old_price.trim();
                                    _product_old_price = _product_old_price.replace('$','');
                                }
                                need_item['_shangjia_minOnSalePriceStr'] = _product_price;
                                need_item['_shangjia_minOriginPriceStr'] = _product_old_price;
                                //
                                let  _product_intro__sizeguide = _dom.find('#fit-sizechartv2-0').html();
                                if(typeof _product_intro__sizeguide == 'undefined'){
                                    _product_intro__sizeguide = '';
                                }else{
                                    _product_intro__sizeguide = "<div class='product-intro__sizeguide'>"+_product_intro__sizeguide+"</div>";
                                }
                                need_item['_product_intro__sizeguide'] = _product_intro__sizeguide;
                                //
                                let _product_about_this_item = _dom.find("#productFactsDesktopExpander .a-expander-content").html();
                                if(typeof _product_about_this_item == 'undefined' || _product_about_this_item==''){
                                    _product_about_this_item = _dom.find('#feature-bullets').html();
                                    if(typeof _product_about_this_item == 'undefined'){
                                        _product_about_this_item = '';
                                    }
                                }
                                if(_product_about_this_item){
                                    _product_about_this_item = _product_about_this_item.replace('<hr>','');
                                    _product_about_this_item = _product_about_this_item.trim();
                                    _product_about_this_item = _product_about_this_item.replace(/<a\b[^>]*>(.*?)<\/a>/gi, '');
                                }
                                need_item['_product_about_this_item'] = _product_about_this_item;
                                //
                                /*let _shangjia_desc = '';//
                                let _shangjia_desc_content = '';
                                let _celwidget_aplus_module_count = _dom.find('#aplus_feature_div #aplus .celwidget.aplus-module').length;
                                let _camc_num = 1;
                                _dom.find('#aplus_feature_div #aplus .celwidget.aplus-module').each(function (){
                                    if(_camc_num < _celwidget_aplus_module_count){
                                        let _celwidget_aplus_module_content = $(this).html();
                                        _celwidget_aplus_module_content = _celwidget_aplus_module_content.replace(/<style\b[^>]*>[\s\S]*?<\/style>/gi, '');
                                        _celwidget_aplus_module_content = _celwidget_aplus_module_content.replace(/<script\b[^>]*>[\s\S]*?<\/script>/gi, '');
                                        if((_shangjia_desc_content.length + _celwidget_aplus_module_content.length) < 32000 ){
                                            _shangjia_desc_content += "<div class='celwidget aplus-module 3p-module-b aplus-standard'>"+_celwidget_aplus_module_content+"</div>";
                                        }
                                    }
                                    _camc_num++;
                                });
                                if(_shangjia_desc_content){
                                    _shangjia_desc = "<div class='product-intro__description'><div class='product-intro__description-table'>"+_shangjia_desc_content+"</div></div>";
                                }
                                need_item['_shangjia_desc'] = _shangjia_desc;*/
                                //
                                let _shangjia_desc = '';
                                _dom.find('#aplus_feature_div #aplus .celwidget.aplus-module').each(function (){
                                    $(this).find("img").each(function (){
                                        let _img = $(this).attr('data-src');
                                        _shangjia_desc += "<img src='"+_img+"'/>";
                                    });
                                });
                                if(_shangjia_desc == ''){
                                    _shangjia_desc = _dom.find("#productDescription").html();
                                }
                                _shangjia_desc = "<div class='product-intro__description'><div class='product-intro__description-table'>"+_shangjia_desc+"</div></div>";
                                //
                                if(pause_setting_desc ==0){
                                    need_item['_shangjia_desc'] = _shangjia_desc;
                                }
                                //
                                let _shangjia_goodsProperty = "";
                                need_item['_shangjia_goodsProperty'] = _shangjia_goodsProperty;
                                //
                                let _shangjia_gallery = util_amz_get_product_lunbo_imgs(_dom);
                                let _shangjia_hdThumbUrl = _shangjia_gallery[0];
                                need_item['_shangjia_hdThumbUrl'] = _shangjia_hdThumbUrl;
                                //
                                need_item['_shangjia_productDetailFlatList'] = [];
                                let _shangjia_VideoUrl = util_amz_get_product_video(data);
                                need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                                //子sku
                                let specs_key1_name = '';
                                let specs_key2_name = '';
                                specs_key1_name = _dom.find('#variation_color_name div.a-row label').text();
                                if(typeof specs_key1_name != "undefined"){
                                    specs_key1_name = specs_key1_name.replace(':','');
                                    specs_key1_name = specs_key1_name.trim();
                                }else{
                                    specs_key1_name = '';
                                }
                                //
                                specs_key2_name = _dom.find('#variation_size_name div.a-row label').text();
                                if(typeof specs_key2_name == 'undefined'){
                                    specs_key2_name = '';
                                }else{
                                    specs_key2_name = specs_key2_name.replace(':','');
                                    specs_key2_name = specs_key2_name.trim();
                                }
                                //如果color存在且大于2个，则不采集
                                let specs_key1_name_values_num = 0;
                                _dom.find('#variation_color_name ul li').each(function (){
                                    specs_key1_name_values_num +=1;
                                });
                                //
                                _dom.find("#variation_color_name select[name='dropdown_selected_color_name'] option").each(function (){
                                    specs_key1_name_values_num +=1;
                                });
                                //
                                let _shangjia_variants_skus = [];
                                if(specs_key1_name_values_num >= 1){
                                    _shangjia_gallery = [];
                                    let _size_arr = [];
                                    //select形式
                                    _dom.find("#variation_size_name select[name='dropdown_selected_size_name'] option").each(function (){
                                        let _option_val = $(this).val();
                                        if(_option_val != '-1'){
                                            let specs_key2_value = $(this).text();
                                            specs_key2_value = specs_key2_value.trim();
                                            _size_arr.push(specs_key2_value);
                                        }
                                    });
                                    //ul li
                                    _dom.find('#variation_size_name ul li').each(function (){
                                        _size_arr.push($(this).find('p').text());
                                    });
                                    //
                                    console.log('_size_arr');
                                    console.log(_size_arr);

                                    let relation_color_arr = [];
                                    _dom.find('#variation_color_name ul li').each(function (){
                                        relation_color_arr.push($(this).attr('data-csa-c-item-id'));
                                    });
                                    //select形式
                                    _dom.find("#variation_color_name select[name='dropdown_selected_color_name'] option").each(function (){
                                        let _color_asin = $(this).val();
                                        if(_color_asin.indexOf(',')!=-1){
                                            let _color_asin_arr  = _color_asin.split(',');
                                            _color_asin = _color_asin_arr[1];
                                        }
                                        relation_color_arr.push(_color_asin);
                                    });
                                    console.log('relation_color_arr');
                                    console.log(relation_color_arr);
                                    //
                                    for(let _r=0;_r<relation_color_arr.length;_r++){
                                        let _shangjia_variants_skus_cucao = shangjia_get_subskus_ajax(
                                            current_domain,
                                            specs_key1_name,
                                            specs_key2_name,
                                            relation_color_arr[_r],
                                            _size_arr);
                                        if(_shangjia_variants_skus_cucao){
                                            for(let _c=0;_c<_shangjia_variants_skus_cucao.length;_c++){
                                                //
                                                if(_c==0){
                                                    //同一个颜色有多个尺寸，只取第一个即可
                                                    let _gallery_imgs = _shangjia_variants_skus_cucao[_c]['gallery_imgs'];
                                                    for(let _g=0;_g<_gallery_imgs.length;_g++){
                                                        _shangjia_gallery.push(_gallery_imgs[_g]);
                                                    }
                                                }
                                                //
                                                _shangjia_variants_skus.push(_shangjia_variants_skus_cucao[_c]);
                                            }
                                        }else{
                                            //可能
                                            console.log('util_get_json可能遇到反爬');
                                            need_item['_is_request'] = 0;
                                            need_item['_error'] = '';
                                            pause_s_time();
                                            sendPopTips("遇到反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                                            //
                                             //
                                            need_item['_e_time'] = Date.now();
                                            let obj = {};
                                            obj[storage_key] = need_item;
                                            chrome.storage.local.set(obj, function (){
                                            });
                                            break;
                                            return;
                                            //
                                        }
                                    }
                                    //
                                }else{
                                    //
                                    if(specs_key2_name){ //有尺寸
                                        let _shangjia_variants_skus_cucao = shangjia_get_subskus(
                                            _dom,
                                            need_item['_shangjia_goodsId'],
                                            specs_key1_name,
                                            '',
                                            specs_key2_name);
                                        for(let _c=0;_c<_shangjia_variants_skus_cucao.length;_c++){
                                            _shangjia_variants_skus.push(_shangjia_variants_skus_cucao[_c]);
                                        }
                                    }else{
                                        //无尺寸,无属性
                                        _shangjia_variants_skus.push({
                                            'subsku': need_item['_shangjia_goodsId'], //
                                            'normalPriceStr': _product_price, //特价
                                            'normalLinePriceStr': _product_old_price, //原价
                                            'img':'',
                                            'gallery_imgs':[],
                                            'video_url':_shangjia_VideoUrl,
                                            'specs_key1_name':'',
                                            'specs_key1_value':'',
                                            'specs_key2_name':'',
                                            'specs_key2_value':'',
                                            'specs_key3_name':'',
                                            'specs_key3_value':'',
                                            'specs_key4_name':'',
                                            'specs_key4_value':'',
                                            'stockQuantity': '',
                                            'skuId': '' //原变体sku
                                        });
                                    }
                                    //
                                }
                                //
                                need_item['_shangjia_variants_skus'] = _shangjia_variants_skus;
                                need_item['_shangjia_gallery'] = _shangjia_gallery;
                                //
                                need_item['_shangjia_sold'] = 0;
                                let _shangjia_review_num = 0;
                                console.log('_shangjia_review_num');
                                console.log(_shangjia_review_num);
                                if(typeof _shangjia_review_num == 'undefined'){
                                    _shangjia_review_num = 0;
                                }else{
                                    _shangjia_review_num = parseInt(_shangjia_review_num);
                                }
                                need_item['_shangjia_reivew_num'] = _shangjia_review_num;
                                console.log('need_item');
                                console.log(need_item);
                                need_item['_is_request'] = 2;
                                //
                            }
                        }
                       //
                   }else{
                       //
                        console.log('scriptdata_json This item is sold out.反爬');
                        need_item['_is_request'] = 0;
                        need_item['_error'] = '';
                        pause_s_time();
                        sendPopTips("遇到反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                        //
                   }
                   //
                   need_item['_e_time'] = Date.now();
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
                   /*if(need_item['_shangjia_img']){
                       urlToBase64(need_item['_shangjia_img'], function(base64String) {
                           //console.log(blob);
                            //need_item['_shangjia_img_blob'] = base64String;
                            //
                            need_item['_is_request'] = 2;
                            need_item['_e_time'] = Date.now();
                            let obj = {};
                            obj[storage_key] = need_item;
                            chrome.storage.local.set(obj, function (){
                            });
                            //
                        });
                   }*/
                   //
               }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('ajax error');
                console.log( jqXHR, textStatus, errorThrown );
                //
                need_item['_is_request'] = 0;
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                        //

                        //
                });
                //
                pause_s_time();
                sendPopTips("遇到Shein反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
            }
        });
        //
    })
}

function request_shangjia_about_contact_and_basic_info(){
    chrome.storage.local.get(null, function(items) {
        //
        let binfa = 0;
        for(let key in items){
             if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                 if(items[key]['_is_request'] == 1){
                     binfa++;
                     if(binfa == 5){
                         break;
                     }
                 }
             }
        }
        if(binfa < 5 || true){
          let need_item = null;
          for(let key in items){
                if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                    if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-10000))){
                        need_item = items[key];
                        need_item['_is_request'] = 1;
                        need_item['_s_time'] = Date.now();
                        let obj = {};
                        obj[key] = need_item;
                        chrome.storage.local.set(obj, function (){
                            //
                            request_shangjia_about_contact_and_basic_info_ajax(key);
                            //
                        });
                        break;
                    }
                }
          }
        }
        //
    });
}

function xintiao(){
     chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             //360000
             if(items.hasOwnProperty('pause_s_time')  && (items['pause_s_time']+60000) > Date.now()){
                console.log('爬取失败，暂停60s');
             }else{
                 console.log('爬取中');
                 request_shangjia_about_contact_and_basic_info();
             }
         }else{
             console.log('已暂停爬取');
         }
    });

    //request_shangjia_about_work_and_education_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao();
setInterval(xintiao, 40000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_about_work_and_education_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'shangjias'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}

function storage_clear_has(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                if(items[key]['_is_request'] == 2){
                    // 清空特定值
                    chrome.storage.local.remove(key, function() {
                       console.log(`键名 ${key} 的值已被清空！`);
                    });
                }
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;
    let has_caiji_company_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }

        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
            'has_caiji_company_num': has_caiji_company_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_shangjias_update(shangjia_infos=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('shangjias', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('shangjias')){
            let obj = {};
            let shangjias = [];
            for(let i=0;i<shangjia_infos.length;i++){
                shangjias.push(shangjia_infos[i]['_shangjia_id']);
            }
            obj['shangjias'] = shangjias;
            chrome.storage.local.set(obj);
        }else{
            let storage_shangjias = items['shangjias'];

            for(let i=0;i<shangjia_infos.length;i++){
                let is_exists = false;
                for(let j=0;j<storage_shangjias.length;j++){
                    if(shangjia_infos[i]['_shangjia_id'] == storage_shangjias[j]){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                    storage_shangjias.push(shangjia_infos[i]['_shangjia_id']);
                }
                //
            }
            //
            let obj = {};
            obj['shangjias'] = storage_shangjias;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if(request.action == 'shangjia_item_url_update'){
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_item_url_set(shangjia_infos[i], (i+1), function (){

           });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        //storage_shangjias_update(shangjia_infos);
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],(i+1),function (){

            });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 1000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'can_list_caiji'){
        console.log('can_list_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            //已开启
            let total_add_shangjia_num = 0;
            for(let key in items){
                if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                    total_add_shangjia_num += 1;
                }
            }
            if(total_add_shangjia_num < 3000){
                sendResponse(JSON.stringify({state:0}));
            }else{
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action == 'check_expire'){
        //
        chrome.storage.local.get(null, function(items) {
            //
            let prefix = 'expire';
            if (!items.hasOwnProperty(prefix)) {
               //
                sendResponse(JSON.stringify({state:1}));
                //
            }else{
                let expire_date = items['expire'];
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                if (util_check_expire(expire_date)) {
                    sendResponse(JSON.stringify({state:1}));
                }else{
                    sendResponse(JSON.stringify({state:0}));
                }
            }
        })
        return true;
        //
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = '', url=''){
    //
    if(url){
        console.log('sendPopTips url:'+url);
        chrome.tabs.create({url: url}, function(newTab) {
            // 监听标签页的更新事件
            chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
              // 检查页面是否已完全加载
              if (tabId === newTab.id && changeInfo.status === "complete") {
                // 在这里执行你想要在页面加载完成后执行的操作
                console.log("页面已完全加载");
                //sendResponse(JSON.stringify({}));
                // 你可以继续在这里添加其他代码
              }
            });
          });
    }
    //
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}