// 使用自定义函数解析查询字符串并返回参数对象
function util_getCurrentUrlQueryStringParams() {
    // 获取当前URL的查询字符串部分
    var queryString = window.location.search;
    var params = {};
    // 移除开头的问号
    queryString = queryString.substring(1);
    // 分割成键值对数组
    var keyValuePairs = queryString.split('&');
    // 遍历键值对数组，将每一对分割成键和值，并存入params对象
    keyValuePairs.forEach(function(keyValuePair) {
        var pair = keyValuePair.split('=');
        var key = decodeURIComponent(pair[0]);
        var value = decodeURIComponent(pair[1] || '');
        params[key] = value;
    });
    return params;
}

function util_get_current_webiste_domain(){
    let current_url = window.location.href;
    if(current_url){
        current_url = current_url.replace('https://','');
        let current_url_arr = current_url.split('/');
        return current_url_arr[0];
    }
    return 'www.amazon.com';
}

//搜索页采集
function extract_shangjias(){
    var message = {
        action: 'can_zidong_caiji',
        info: ''
    };
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('extract_shangjias zidong_caiji_next',msg)
        let msgobj  = JSON.parse(msg);
        console.log(msgobj['state']);
        if(msgobj['state'] == 0){ //可以自动采集
            console.log('extract_shangjias zidong_caiji_next a1');
            //
            let current_url = window.location.href;
            //
            current_url = current_url.replace('https://','');
            current_url_arr = current_url.split('/');
            current_amz_site = current_url_arr[0];
            //
            var shangjia_infos = [];
            $('.s-result-list .s-result-item').each(function (){
                //
                let shangjia_item_url = '';
                let _shangjia_item_url = $(this).find('h2 a').attr('href');
                if(_shangjia_item_url){
                    if(_shangjia_item_url.indexOf('https') ==-1){
                        shangjia_item_url = 'https://'+current_amz_site+_shangjia_item_url;
                    }else{
                        shangjia_item_url = _shangjia_item_url;
                    }
                    //
                    var shangjia_info = {
                        'shangjia_item_url':shangjia_item_url
                    };
                    shangjia_infos.push(shangjia_info);
                    //
                }
            });
            //gg
            $('ol[role="list"] li.a-carousel-card').each(function (){
                //
                let shangjia_item_url = '';
                let _shangjia_item_url = $(this).find('a:eq(0)').attr('href');
                if(_shangjia_item_url){
                     if(_shangjia_item_url.indexOf('https') ==-1){
                        shangjia_item_url = 'https://'+current_amz_site+_shangjia_item_url;
                    }else{
                        shangjia_item_url = _shangjia_item_url;
                    }
                    //
                    var shangjia_info = {
                        'shangjia_item_url':shangjia_item_url
                    };
                    shangjia_infos.push(shangjia_info);
                    //
                }
            });
            //today's deals
            $('.p13n-gridRow .a-column').each(function (){
                //
                let shangjia_item_url = '';
                let _shangjia_item_url = $(this).find('a.a-link-normal:first-child').attr('href');
                if(_shangjia_item_url){
                    if(_shangjia_item_url.indexOf('https') ==-1){
                        shangjia_item_url = 'https://'+current_amz_site+_shangjia_item_url;
                    }else{
                        shangjia_item_url = _shangjia_item_url;
                    }
                    //
                    var shangjia_info = {
                        'shangjia_item_url':shangjia_item_url
                    };
                    shangjia_infos.push(shangjia_info);
                    //
                }
            });
            //best seller
            let _f = 0;
            $('.p13n-desktop-grid .a-column').each(function (){
                 //
                let shangjia_item_url = '';
                let _shangjia_item_url = $(this).find('a:eq(0)').attr('href');
                if(_shangjia_item_url){
                    if(_shangjia_item_url.indexOf('https') ==-1){
                        shangjia_item_url = 'https://'+current_amz_site+_shangjia_item_url;
                    }else{
                        shangjia_item_url = _shangjia_item_url;
                    }
                    var shangjia_info = {
                        'shangjia_item_url':shangjia_item_url
                    };
                    shangjia_infos.push(shangjia_info);
                    //
                    _f++;
                    console.log('best seller:'+_f);
                }
            });
            //
            console.log('shangjia_infos');
            console.log(shangjia_infos);
            //
            var message = {
                action: 'shangjia_item_url_update',
                info: '',
                shangjia_infos: shangjia_infos
            };
            send_message_to_background(message);
            //处理自动化采集
            let _next_url = $('.s-pagination-container a.s-pagination-next').attr('href');
            if(_next_url){
                _next_url  = 'https://'+current_amz_site + _next_url;
                setTimeout(function (){
                     //zidong_caiji_next(_next_url);
                    window.location.href = _next_url;
                },5000);
            }
            //
            //
        }
    })
}

function zidong_caiji_next(next_url = ''){
    console.log('zidong_caiji_next s');
    var message = {
        action: 'can_zidong_caiji',
        info: ''
    };
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('zidong_caiji_next 答复',msg)
        let msgobj  = JSON.parse(msg);
        console.log(msgobj['state']);
        if(msgobj['state'] == 0){ //可以自动采集
            console.log('zidong_caiji_next s2');
            window.location.href = next_url;
        }
    })
}

function util_timeConsumingFunction(seconds) {
  // 将秒数转换为毫秒
  const milliseconds = seconds * 1000;

  // 模拟耗时操作，例如循环计算
  const startTime = new Date().getTime();
  while (new Date().getTime() - startTime < milliseconds) {
    // 一些计算
  }
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            if(performanceResourceItem['name'].indexOf('s/query')!=-1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                setTimeout(function (){
                    extract_shangjias();
                },1000);
            }else if(performanceResourceItem['name'].indexOf('nextPage?page-type=')!=-1){
                setTimeout(function (){
                            extract_shangjias();
                        },2000);
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
observer_.observe({entryTypes:['resource', 'navigation', 'paint']});


function util_getFileExtension(filename = '') {
    return filename.slice(filename.lastIndexOf('.') + 1);
}

function util_getasin(url = ''){
    let _url_arr = url.split('?');
    let _url = _url_arr[0];
    let _shangjia_id_str = _url;
    let _shangjia_id_arr = _shangjia_id_str.split('/dp/');
    _shangjia_id_str = _shangjia_id_arr[1];
    if(_shangjia_id_str.indexOf('/')!=-1){
        let _shangjia_id_str_arr2 = _shangjia_id_str.split('/');
        _shangjia_id_str = _shangjia_id_str_arr2[0];
    }
    let asin = _shangjia_id_str;
    return asin;
}

function util_get_current_webiste_domain(url=''){
    let current_url = url;
    if(current_url){
        current_url = current_url.replace('https://','');
        let current_url_arr = current_url.split('/');
        return current_url_arr[0];
    }
    return 'www.amazon.com';
}

function util_amz_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('ImageBlockATF') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_amz_get_product_lunbo_imgs(_dom){
   let _leftColHtml =  _dom.find('#leftCol').html();
   let _amz_script = util_amz_getscript_pageData_content(_leftColHtml);
   //console.log('_amz_script');
   //console.log(_amz_script);
   let _amz_script_tmp_arr = _amz_script.split("var data =");
   let _amz_script_tmp_str = _amz_script_tmp_arr[1];
   let _amz_script_tmp_str_arr = _amz_script_tmp_str.split('A.trigger');
   let _amz_script_imgs_str = _amz_script_tmp_str_arr[0];
   _amz_script_imgs_str = _amz_script_imgs_str.trim();
   _amz_script_imgs_str = _amz_script_imgs_str.slice(0,-1);
   //
    let _amz_script_imgs_tmp_arr  = _amz_script_imgs_str.split("'colorImages':");
    //
    let _amz_script_imgs_temp2 = _amz_script_imgs_tmp_arr[1];
    let _amz_script_imgs_temp2_str = _amz_script_imgs_temp2.split("'colorToAsin'");
    let _amz_script_imgs = _amz_script_imgs_temp2_str[0];
    _amz_script_imgs = _amz_script_imgs.trim();
    _amz_script_imgs = _amz_script_imgs.slice(0,-1);
    _amz_script_imgs = _amz_script_imgs.replace("{ 'initial':","");
    _amz_script_imgs = _amz_script_imgs.slice(0,-1);
    let _amz_script_imgs_arr = JSON.parse(_amz_script_imgs);
    console.log('_amz_script_imgs_arr');
    console.log(_amz_script_imgs_arr);
    //
    let _images = [];
    let _sort = 1;
    for(let i=0;i<_amz_script_imgs_arr.length;i++){
        let _img = _amz_script_imgs_arr[i]['large'];
        if(_img){
            _images.push(_img);
            _sort++;
        }
    }
    return _images;
    //
}

function util_amz_get_product_video(html = ''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('awaConfig') !=-1 && scriptContent.indexOf('videoUrl') !=-1){
                //
                let scriptContent_JSON = JSON.parse(scriptContent);
                console.log('scriptContent_JSON');
                console.log(scriptContent_JSON);
                return scriptContent_JSON['videoUrl'];
                //
            }
        }
    }
    //triggerVideoAjax
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('triggerVideoAjax') !=-1){
                //
                let scriptContentArr = scriptContent.split('triggerVideoAjax');
                if(scriptContentArr.length > 1){
                    let _scriptContent = scriptContentArr[1];
                    let _scriptContentArr = _scriptContent.split("A.$.parseJSON(");
                    let _scriptContent2 = _scriptContentArr[1];
                    let _scriptContent2Arr = _scriptContent2.split("A.trigger");
                    let _scriptContent3 = _scriptContent2Arr[0];
                    _scriptContent3 = _scriptContent3.substring(1);
                    _scriptContent3 = _scriptContent3.slice(0,-4);
                    let scriptContent_JSON = JSON.parse(_scriptContent3);
                    let videos = scriptContent_JSON['videos'];
                    for(let _v_key in videos){
                        let _video_url = videos[_v_key]['url'];
                        if(util_getFileExtension(_video_url) == 'mp4'){
                            return _video_url;
                        }
                    }
                }
                //
            }
        }
    }
    //
    return '';
}

function exportToCsv(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".csv");
}

function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}

function export_normal_xlsx_output(need_item){
    let export_datas = [];
    //
    if (true) {
        let shangjia_about_contact_and_basic_info = need_item;
        let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
        let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
        let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

        let futu1 = '';
        let futu2 = '';
        let futu3 = '';
        let futu4 = '';
        let futu5 = '';

        let futu6 = '';
        let futu7 = '';
        let futu8 = '';
        let futu9 = '';
        let futu10 = '';

        let futu11 = '';
        let futu12 = '';
        let futu13 = '';
        let futu14 = '';
        let futu15 = '';

        let futu16 = '';
        let futu17 = '';
        let futu18 = '';
        let futu19 = '';
        let futu20 = '';

        if(_shangjia_gallery_arr.length>=1){
            futu1 = _shangjia_gallery_arr[0];
        }
        if(_shangjia_gallery_arr.length>=2){
            futu2 = _shangjia_gallery_arr[1];
        }
        if(_shangjia_gallery_arr.length>=3){
            futu3 = _shangjia_gallery_arr[2];
        }
        if(_shangjia_gallery_arr.length>=4){
            futu4 = _shangjia_gallery_arr[3];
        }
        if(_shangjia_gallery_arr.length>=5){
            futu5 = _shangjia_gallery_arr[4];
        }
        if(_shangjia_gallery_arr.length>=6){
            futu6 = _shangjia_gallery_arr[5];
        }
        if(_shangjia_gallery_arr.length>=7){
            futu7 = _shangjia_gallery_arr[6];
        }
        if(_shangjia_gallery_arr.length>=8){
            futu8 = _shangjia_gallery_arr[7];
        }
        if(_shangjia_gallery_arr.length>=9){
            futu9 = _shangjia_gallery_arr[8];
        }
        if(_shangjia_gallery_arr.length>=10){
            futu10 = _shangjia_gallery_arr[9];
        }
        if(_shangjia_gallery_arr.length>=11){
            futu11 = _shangjia_gallery_arr[10];
        }
        if(_shangjia_gallery_arr.length>=12){
            futu12 = _shangjia_gallery_arr[11];
        }
        if(_shangjia_gallery_arr.length>=13){
            futu13 = _shangjia_gallery_arr[12];
        }
        if(_shangjia_gallery_arr.length>=14){
            futu14 = _shangjia_gallery_arr[13];
        }
        if(_shangjia_gallery_arr.length>=15){
            futu15 = _shangjia_gallery_arr[14];
        }
        if(_shangjia_gallery_arr.length>=16){
            futu16 = _shangjia_gallery_arr[15];
        }
        if(_shangjia_gallery_arr.length>=17){
            futu17 = _shangjia_gallery_arr[16];
        }
        if(_shangjia_gallery_arr.length>=18){
            futu18 = _shangjia_gallery_arr[17];
        }
        if(_shangjia_gallery_arr.length>=19){
            futu19 = _shangjia_gallery_arr[18];
        }
        if(_shangjia_gallery_arr.length>=20){
            futu20 = _shangjia_gallery_arr[19];
        }
        //
        let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
        //
        /*let _shangjia_product_link = '';
        let _shangjia_a_link = window.location.href;
        if(_shangjia_a_link.indexOf('?')!=-1){
            let _shangjia_a_link_arr = _shangjia_a_link.split('?');
            _shangjia_product_link = _shangjia_a_link_arr[0];
            let _shangjia_a_link_args = _shangjia_a_link_arr[1];
            let _shangjia_a_link_args_arr = _shangjia_a_link_args.split('&');
            let _gid_arg = _shangjia_a_link_args_arr[0];
            _shangjia_product_link +='?'+_gid_arg;
        }*/
        let _main_img = shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'];
        let _shangjia_VideoUrl = shangjia_about_contact_and_basic_info['_shangjia_VideoUrl'];
        //
        for(let i=0;i<_shangjia_variants_skus.length;i++){
            //
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
            let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
            //
            if(_shangjia_variants_skus[i]['img']){
                _main_img = _shangjia_variants_skus[i]['img'];
            }
            let _shangjia_variants_skus_gallery_imgs = _shangjia_variants_skus[i]['gallery_imgs'];
            if(_shangjia_variants_skus[i]['gallery_imgs'] && _shangjia_variants_skus_gallery_imgs.length > 0){
                futu1 = futu2 = futu3 = futu4 = futu5 = futu6 = futu7 = futu8 = futu9 = futu10 = '';
                futu11 = futu12 = futu13 = futu14 = futu15 = futu16 = futu17 = futu18 = futu19 = futu20 = ''

                let gallery_imgs = _shangjia_variants_skus[i]['gallery_imgs'];
                console.log('gallery_imgs');
                console.log(gallery_imgs);
                if(gallery_imgs.length>=2){
                    futu1 = gallery_imgs[1];
                }
                if(gallery_imgs.length>=3){
                    futu2 = gallery_imgs[2];
                }
                if(gallery_imgs.length>=4){
                    futu3 = gallery_imgs[3];
                }
                if(gallery_imgs.length>=5){
                    futu4 = gallery_imgs[4];
                }
                if(gallery_imgs.length>=6){
                    futu5 = gallery_imgs[5];
                }
                if(gallery_imgs.length>=7){
                    futu6 = gallery_imgs[6];
                }
                if(gallery_imgs.length>=8){
                    futu7 = gallery_imgs[7];
                }
                if(gallery_imgs.length>=9){
                    futu8 = gallery_imgs[8];
                }
                if(gallery_imgs.length>=10){
                    futu9 = gallery_imgs[9];
                }
                if(gallery_imgs.length>=11){
                    futu10 = gallery_imgs[10];
                }
                if(gallery_imgs.length>=12){
                    futu11 = gallery_imgs[11];
                }
                if(gallery_imgs.length>=13){
                    futu12 = gallery_imgs[12];
                }
                if(gallery_imgs.length>=14){
                    futu13 = gallery_imgs[13];
                }
                if(gallery_imgs.length>=15){
                    futu14 = gallery_imgs[14];
                }
                if(gallery_imgs.length>=16){
                    futu15 = gallery_imgs[15];
                }
                if(gallery_imgs.length>=17){
                    futu16 = gallery_imgs[16];
                }
                if(gallery_imgs.length>=18){
                    futu17 = gallery_imgs[17];
                }
                if(gallery_imgs.length>=19){
                    futu18 = gallery_imgs[18];
                }
                if(gallery_imgs.length>=20){
                    futu19 = gallery_imgs[19];
                }
                if(gallery_imgs.length>=21){
                    futu20 = gallery_imgs[20];
                }
            }
            if(_shangjia_variants_skus[i]['video_url']){
                _shangjia_VideoUrl = _shangjia_variants_skus[i]['video_url'];
            }
            //
            let export_data_item = {
                '产品url': shangjia_about_contact_and_basic_info['_product_url'],
                'SKU': shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
                //'原变体SKU': _shangjia_variants_skus[i]['skuId'],
                '变体带属性SKU': (specs_key1_name || specs_key2_name) ? _shangjia_variants_skus[i]['subsku'] : '',
                '产品标题': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                //'Category': shangjia_about_contact_and_basic_info['_shangjia_category'],
                '变体图片': (specs_key1_name || specs_key2_name) ? _main_img : '',
                '价格': _shangjia_variants_skus[i]['normalPriceStr'],
                '原价': _shangjia_variants_skus[i]['normalLinePriceStr'],
                '变体库存': _shangjia_variants_skus[i]['stockQuantity'],
                '属性1名': specs_key1_name,
                '属性1值': _shangjia_variants_skus[i]['specs_key1_value'],
                '属性图片': _shangjia_variants_skus[i]['color_image'],
                '属性2名': specs_key2_name,
                '属性2值': _shangjia_variants_skus[i]['specs_key2_value'],
                '属性图片': _shangjia_variants_skus[i]['color_image'],
                //'属性3名': specs_key3_name,
                //'属性3值': _shangjia_variants_skus[i]['specs_key3_value'],
                //'属性4名': specs_key4_name,
                //'属性4值': _shangjia_variants_skus[i]['specs_key4_value'],
                '图1': _main_img,
                '图1': futu1,
                '图2': futu2,
                '图3': futu3,
                '图4': futu4,
                '图5': futu5,
                '图6': futu6,
                '图7': futu7,
                '图8': futu8,
                '图9': futu9,
                '图10': futu10,
                '图11': futu11,
                '图12': futu12,
                '图13': futu13,
                '图14': futu14,
                '图15': futu15,
                '图16': futu16,
                '图17': futu17,
                '图18': futu18,
                '图19': futu19,
                '图20': futu20,
                'VideoUrl': _shangjia_VideoUrl,
                'Size & Fit': shangjia_about_contact_and_basic_info['_product_intro__sizeguide'],
                //'产品属性': shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'],
                'About this item': shangjia_about_contact_and_basic_info['_product_about_this_item'],
                'Product Description': shangjia_about_contact_and_basic_info['_shangjia_desc'],
                //'描述图片': shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'].join(','),
                //review
                //'review': shangjia_about_contact_and_basic_info['_shangjia_reivew_num'],
                //'sold': _shangjia_sold,
                //
                //'is request': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '已完成':'未',
            }
            export_datas.push(export_data_item);
            //
        }
        console.log('export_datas');
        console.log(export_datas);
        exportToExcel(export_datas, 'gycharm-amazon-normal-export-'+_shangjia_goodsId, "Sheet1");
    }
}

function export_shopify_csv_output(need_item, pingtai){
    let export_datas = [];
    //
    if (true) {
        let shangjia_about_contact_and_basic_info = need_item;
        let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
        //
        let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
        //
        let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

        let futu1 = '';
        let futu2 = '';
        let futu3 = '';
        let futu4 = '';
        let futu5 = '';

        let futu6 = '';
        let futu7 = '';
        let futu8 = '';
        let futu9 = '';
        let futu10 = '';

        let futu11 = '';
        let futu12 = '';
        let futu13 = '';
        let futu14 = '';
        let futu15 = '';

        let futu16 = '';
        let futu17 = '';
        let futu18 = '';
        let futu19 = '';
        let futu20 = '';

        let futu21 = '';
        let futu22 = '';
        let futu23 = '';
        let futu24 = '';
        let futu25 = '';
        let futu26 = '';
        let futu27 = '';
        let futu28 = '';
        let futu29 = '';
        let futu30 = '';

        let futu31 = '';
        let futu32 = '';
        let futu33 = '';
        let futu34 = '';
        let futu35 = '';
        let futu36 = '';
        let futu37 = '';
        let futu38 = '';
        let futu39 = '';
        let futu40 = '';

        let futu41 = '';
        let futu42 = '';
        let futu43 = '';
        let futu44 = '';
        let futu45 = '';
        let futu46 = '';
        let futu47 = '';
        let futu48 = '';
        let futu49 = '';
        let futu50 = '';

        let futu51 = '';
        let futu52 = '';
        let futu53 = '';
        let futu54 = '';
        let futu55 = '';
        let futu56 = '';
        let futu57 = '';
        let futu58 = '';
        let futu59 = '';
        let futu60 = '';

        let futu61 = '';
        let futu62 = '';
        let futu63 = '';
        let futu64 = '';
        let futu65 = '';
        let futu66 = '';
        let futu67 = '';
        let futu68 = '';
        let futu69 = '';
        let futu70 = '';

        let futu71 = '';
        let futu72 = '';
        let futu73 = '';
        let futu74 = '';
        let futu75 = '';
        let futu76 = '';
        let futu77 = '';
        let futu78 = '';
        let futu79 = '';
        let futu80 = '';

        let futu81 = '';
        let futu82 = '';
        let futu83 = '';
        let futu84 = '';
        let futu85 = '';
        let futu86 = '';
        let futu87 = '';
        let futu88 = '';
        let futu89 = '';
        let futu90 = '';

        let futu91 = '';
        let futu92 = '';
        let futu93 = '';
        let futu94 = '';
        let futu95 = '';
        let futu96 = '';
        let futu97 = '';
        let futu98 = '';
        let futu99 = '';
        let futu100 = '';

        if(_shangjia_gallery_arr.length>=1){
            futu1 = _shangjia_gallery_arr[0];
        }
        if(_shangjia_gallery_arr.length>=2){
            futu2 = _shangjia_gallery_arr[1];
        }
        if(_shangjia_gallery_arr.length>=3){
            futu3 = _shangjia_gallery_arr[2];
        }
        if(_shangjia_gallery_arr.length>=4){
            futu4 = _shangjia_gallery_arr[3];
        }
        if(_shangjia_gallery_arr.length>=5){
            futu5 = _shangjia_gallery_arr[4];
        }
        if(_shangjia_gallery_arr.length>=6){
            futu6 = _shangjia_gallery_arr[5];
        }
        if(_shangjia_gallery_arr.length>=7){
            futu7 = _shangjia_gallery_arr[6];
        }
        if(_shangjia_gallery_arr.length>=8){
            futu8 = _shangjia_gallery_arr[7];
        }
        if(_shangjia_gallery_arr.length>=9){
            futu9 = _shangjia_gallery_arr[8];
        }
        if(_shangjia_gallery_arr.length>=10){
            futu10 = _shangjia_gallery_arr[9];
        }
        if(_shangjia_gallery_arr.length>=11){
            futu11 = _shangjia_gallery_arr[10];
        }
        if(_shangjia_gallery_arr.length>=12){
            futu12 = _shangjia_gallery_arr[11];
        }
        if(_shangjia_gallery_arr.length>=13){
            futu13 = _shangjia_gallery_arr[12];
        }
        if(_shangjia_gallery_arr.length>=14){
            futu14 = _shangjia_gallery_arr[13];
        }
        if(_shangjia_gallery_arr.length>=15){
            futu15 = _shangjia_gallery_arr[14];
        }
        if(_shangjia_gallery_arr.length>=16){
            futu16 = _shangjia_gallery_arr[15];
        }
        if(_shangjia_gallery_arr.length>=17){
            futu17 = _shangjia_gallery_arr[16];
        }
        if(_shangjia_gallery_arr.length>=18){
            futu18 = _shangjia_gallery_arr[17];
        }
        if(_shangjia_gallery_arr.length>=19){
            futu19 = _shangjia_gallery_arr[18];
        }
        if(_shangjia_gallery_arr.length>=20){
            futu20 = _shangjia_gallery_arr[19];
        }

        if(_shangjia_gallery_arr.length>=21){
            futu21= _shangjia_gallery_arr[20];
        }
        if(_shangjia_gallery_arr.length>=22){
            futu22 = _shangjia_gallery_arr[21];
        }
        if(_shangjia_gallery_arr.length>=23){
            futu23 = _shangjia_gallery_arr[22];
        }
        if(_shangjia_gallery_arr.length>=24){
            futu24 = _shangjia_gallery_arr[23];
        }
        if(_shangjia_gallery_arr.length>=25){
            futu25 = _shangjia_gallery_arr[24];
        }
        if(_shangjia_gallery_arr.length>=26){
            futu26 = _shangjia_gallery_arr[25];
        }
        if(_shangjia_gallery_arr.length>=27){
            futu27 = _shangjia_gallery_arr[26];
        }
        if(_shangjia_gallery_arr.length>=28){
            futu28 = _shangjia_gallery_arr[27];
        }
        if(_shangjia_gallery_arr.length>=29){
            futu29 = _shangjia_gallery_arr[28];
        }
        if(_shangjia_gallery_arr.length>=30){
            futu30 = _shangjia_gallery_arr[29];
        }
        if(_shangjia_gallery_arr.length>=31){
            futu31 = _shangjia_gallery_arr[30];
        }
        if(_shangjia_gallery_arr.length>=32){
            futu32 = _shangjia_gallery_arr[31];
        }
        if(_shangjia_gallery_arr.length>=33){
            futu33 = _shangjia_gallery_arr[32];
        }
        if(_shangjia_gallery_arr.length>=34){
            futu34 = _shangjia_gallery_arr[33];
        }
        if(_shangjia_gallery_arr.length>=35){
            futu35 = _shangjia_gallery_arr[34];
        }
        if(_shangjia_gallery_arr.length>=36){
            futu36 = _shangjia_gallery_arr[35];
        }
        if(_shangjia_gallery_arr.length>=37){
            futu37 = _shangjia_gallery_arr[36];
        }
        if(_shangjia_gallery_arr.length>=38){
            futu38 = _shangjia_gallery_arr[37];
        }
        if(_shangjia_gallery_arr.length>=39){
            futu39 = _shangjia_gallery_arr[38];
        }
        if(_shangjia_gallery_arr.length>=40){
            futu40 = _shangjia_gallery_arr[39];
        }
        if(_shangjia_gallery_arr.length>=41){
            futu41 = _shangjia_gallery_arr[40];
        }
        if(_shangjia_gallery_arr.length>=42){
            futu42 = _shangjia_gallery_arr[41];
        }
        if(_shangjia_gallery_arr.length>=43){
            futu43 = _shangjia_gallery_arr[42];
        }
        if(_shangjia_gallery_arr.length>=44){
            futu44 = _shangjia_gallery_arr[43];
        }
        if(_shangjia_gallery_arr.length>=45){
            futu45 = _shangjia_gallery_arr[44];
        }
        if(_shangjia_gallery_arr.length>=46){
            futu46 = _shangjia_gallery_arr[45];
        }
        if(_shangjia_gallery_arr.length>=47){
            futu47 = _shangjia_gallery_arr[46];
        }
        if(_shangjia_gallery_arr.length>=48){
            futu48 = _shangjia_gallery_arr[47];
        }
        if(_shangjia_gallery_arr.length>=49){
            futu49 = _shangjia_gallery_arr[48];
        }
        if(_shangjia_gallery_arr.length>=50){
            futu50 = _shangjia_gallery_arr[49];
        }
        if(_shangjia_gallery_arr.length>=51){
            futu51 = _shangjia_gallery_arr[50];
        }
        if(_shangjia_gallery_arr.length>=52){
            futu52 = _shangjia_gallery_arr[51];
        }
        if(_shangjia_gallery_arr.length>=53){
            futu53 = _shangjia_gallery_arr[52];
        }
        if(_shangjia_gallery_arr.length>=54){
            futu54 = _shangjia_gallery_arr[53];
        }
        if(_shangjia_gallery_arr.length>=55){
            futu55 = _shangjia_gallery_arr[54];
        }
        if(_shangjia_gallery_arr.length>=56){
            futu56 = _shangjia_gallery_arr[55];
        }
        if(_shangjia_gallery_arr.length>=57){
            futu57 = _shangjia_gallery_arr[56];
        }
        if(_shangjia_gallery_arr.length>=58){
            futu58 = _shangjia_gallery_arr[57];
        }
        if(_shangjia_gallery_arr.length>=59){
            futu59 = _shangjia_gallery_arr[58];
        }
        if(_shangjia_gallery_arr.length>=60){
            futu60 = _shangjia_gallery_arr[59];
        }

        if(_shangjia_gallery_arr.length>=61){
            futu61 = _shangjia_gallery_arr[60];
        }
        if(_shangjia_gallery_arr.length>=62){
            futu62 = _shangjia_gallery_arr[61];
        }
        if(_shangjia_gallery_arr.length>=63){
            futu63 = _shangjia_gallery_arr[62];
        }
        if(_shangjia_gallery_arr.length>=64){
            futu64 = _shangjia_gallery_arr[63];
        }
        if(_shangjia_gallery_arr.length>=65){
            futu65 = _shangjia_gallery_arr[64];
        }
        if(_shangjia_gallery_arr.length>=66){
            futu66 = _shangjia_gallery_arr[65];
        }
        if(_shangjia_gallery_arr.length>=67){
            futu67 = _shangjia_gallery_arr[66];
        }
        if(_shangjia_gallery_arr.length>=68){
            futu68 = _shangjia_gallery_arr[67];
        }
        if(_shangjia_gallery_arr.length>=69){
            futu69 = _shangjia_gallery_arr[68];
        }
        if(_shangjia_gallery_arr.length>=70){
            futu70 = _shangjia_gallery_arr[69];
        }
        if(_shangjia_gallery_arr.length>=71){
            futu71 = _shangjia_gallery_arr[70];
        }
        if(_shangjia_gallery_arr.length>=72){
            futu72 = _shangjia_gallery_arr[71];
        }
        if(_shangjia_gallery_arr.length>=73){
            futu73 = _shangjia_gallery_arr[72];
        }
        if(_shangjia_gallery_arr.length>=74){
            futu74 = _shangjia_gallery_arr[73];
        }
        if(_shangjia_gallery_arr.length>=75){
            futu75 = _shangjia_gallery_arr[74];
        }
        if(_shangjia_gallery_arr.length>=76){
            futu76 = _shangjia_gallery_arr[75];
        }
        if(_shangjia_gallery_arr.length>=77){
            futu77 = _shangjia_gallery_arr[76];
        }
        if(_shangjia_gallery_arr.length>=78){
            futu78 = _shangjia_gallery_arr[77];
        }
        if(_shangjia_gallery_arr.length>=79){
            futu79 = _shangjia_gallery_arr[78];
        }
        if(_shangjia_gallery_arr.length>=80){
            futu80 = _shangjia_gallery_arr[79];
        }

        if(_shangjia_gallery_arr.length>=81){
            futu81 = _shangjia_gallery_arr[80];
        }
        if(_shangjia_gallery_arr.length>=82){
            futu82 = _shangjia_gallery_arr[81];
        }
        if(_shangjia_gallery_arr.length>=83){
            futu83 = _shangjia_gallery_arr[82];
        }
        if(_shangjia_gallery_arr.length>=84){
            futu84 = _shangjia_gallery_arr[83];
        }
        if(_shangjia_gallery_arr.length>=85){
            futu85 = _shangjia_gallery_arr[84];
        }
        if(_shangjia_gallery_arr.length>=86){
            futu86 = _shangjia_gallery_arr[85];
        }
        if(_shangjia_gallery_arr.length>=87){
            futu87 = _shangjia_gallery_arr[86];
        }
        if(_shangjia_gallery_arr.length>=88){
            futu88 = _shangjia_gallery_arr[87];
        }
        if(_shangjia_gallery_arr.length>=89){
            futu89 = _shangjia_gallery_arr[88];
        }
        if(_shangjia_gallery_arr.length>=90){
            futu90 = _shangjia_gallery_arr[89];
        }
        if(_shangjia_gallery_arr.length>=91){
            futu91 = _shangjia_gallery_arr[90];
        }
        if(_shangjia_gallery_arr.length>=92){
            futu92 = _shangjia_gallery_arr[91];
        }
        if(_shangjia_gallery_arr.length>=93){
            futu93 = _shangjia_gallery_arr[92];
        }
        if(_shangjia_gallery_arr.length>=94){
            futu94 = _shangjia_gallery_arr[93];
        }
        if(_shangjia_gallery_arr.length>=95){
            futu95 = _shangjia_gallery_arr[94];
        }
        if(_shangjia_gallery_arr.length>=96){
            futu96 = _shangjia_gallery_arr[95];
        }
        if(_shangjia_gallery_arr.length>=97){
            futu97 = _shangjia_gallery_arr[96];
        }
        if(_shangjia_gallery_arr.length>=98){
            futu98 = _shangjia_gallery_arr[97];
        }
        if(_shangjia_gallery_arr.length>=99){
            futu99 = _shangjia_gallery_arr[98];
        }
        if(_shangjia_gallery_arr.length>=100){
            futu100 = _shangjia_gallery_arr[99];
        }
        //
        let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
        //
        let _body_html = shangjia_about_contact_and_basic_info['_shangjia_desc'];
        if(pingtai == 'shopify2'){
            _body_html = shangjia_about_contact_and_basic_info['_product_about_this_item'];
        }
        /*let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
        let _shangjia_productDetailFlatList_html = '';
        for(_f=0;_f<_shangjia_productDetailFlatList.length;_f++){
            _shangjia_productDetailFlatList_html += "<img src='"+_shangjia_productDetailFlatList[_f]+"' />";
        }
        _body_html += "<br />"+_shangjia_productDetailFlatList_html;*/
        //
        let _product_url = need_item['_product_url'];
        let _Handle = 'goods-detail-'+need_item['_shangjia_goodsId'];
        for(let i=0;i<_shangjia_variants_skus.length;i++){
            //
            let imgsrc = '';
            if(i==0){
                imgsrc = futu1;
            }else if(i==1){
                imgsrc = futu2;
            }else if(i==2){
                imgsrc = futu3;
            }else if(i==3){
                imgsrc = futu4;
            }else if(i==4){
                imgsrc = futu5;
            }else if(i==5){
                imgsrc = futu6;
            }else if(i==6){
                imgsrc = futu7;
            }else if(i==7){
                imgsrc = futu8;
            }else if(i==8){
                imgsrc = futu9;
            }else if(i==9){
                imgsrc = futu10;
            }else if(i==10){
                imgsrc = futu11;
            }else if(i==11){
                imgsrc = futu12;
            }else if(i==12){
                imgsrc = futu13;
            }else if(i==13){
                imgsrc = futu14;
            }else if(i==14){
                imgsrc = futu15;
            }else if(i==15){
                imgsrc = futu16;
            }else if(i==16){
                imgsrc = futu17;
            }else if(i==17){
                imgsrc = futu18;
            }else if(i==18){
                imgsrc = futu19;
            }else if(i==19){
                imgsrc = futu20;
            }else if(i==20){
                imgsrc = futu21;
            }else if(i==21){
                imgsrc = futu22;
            }else if(i==22){
                imgsrc = futu23;
            }else if(i==23){
                imgsrc = futu24;
            }else if(i==24){
                imgsrc = futu25;
            }else if(i==25){
                imgsrc = futu26;
            }else if(i==26){
                imgsrc = futu27;
            }else if(i==27){
                imgsrc = futu28;
            }else if(i==28){
                imgsrc = futu29;
            }else if(i==29){
                imgsrc = futu30;
            }else if(i==30){
                imgsrc = futu31;
            }else if(i==31){
                imgsrc = futu32;
            }else if(i==32){
                imgsrc = futu33;
            }else if(i==33){
                imgsrc = futu34;
            }else if(i==34){
                imgsrc = futu35;
            }else if(i==35){
                imgsrc = futu36;
            }else if(i==36){
                imgsrc = futu37;
            }else if(i==37){
                imgsrc = futu38;
            }else if(i==38){
                imgsrc = futu39;
            }else if(i==39){
                imgsrc = futu40;
            }else if(i==40){
                imgsrc = futu41;
            }else if(i==41){
                imgsrc = futu42;
            }else if(i==42){
                imgsrc = futu43;
            }else if(i==43){
                imgsrc = futu44;
            }else if(i==44){
                imgsrc = futu45;
            }else if(i==45){
                imgsrc = futu46;
            }else if(i==46){
                imgsrc = futu47;
            }else if(i==47){
                imgsrc = futu48;
            }else if(i==48){
                imgsrc = futu49;
            }else if(i==49){
                imgsrc = futu50;
            }else if(i==50){
                imgsrc = futu51;
            }else if(i==51){
                imgsrc = futu52;
            }else if(i==52){
                imgsrc = futu53;
            }else if(i==53){
                imgsrc = futu54;
            }else if(i==54){
                imgsrc = futu55;
            }else if(i==55){
                imgsrc = futu56;
            }else if(i==56){
                imgsrc = futu57;
            }else if(i==57){
                imgsrc = futu58;
            }else if(i==58){
                imgsrc = futu59;
            }else if(i==59){
                imgsrc = futu60;
            }else if(i==60){
                imgsrc = futu61;
            }else if(i==61){
                imgsrc = futu62;
            }else if(i==62){
                imgsrc = futu63;
            }else if(i==63){
                imgsrc = futu64;
            }else if(i==64){
                imgsrc = futu65;
            }else if(i==65){
                imgsrc = futu66;
            }else if(i==66){
                imgsrc = futu67;
            }else if(i==67){
                imgsrc = futu68;
            }else if(i==68){
                imgsrc = futu69;
            }else if(i==69){
                imgsrc = futu70;
            }else if(i==70){
                imgsrc = futu71;
            }else if(i==71){
                imgsrc = futu72;
            }else if(i==72){
                imgsrc = futu73;
            }else if(i==73){
                imgsrc = futu74;
            }else if(i==74){
                imgsrc = futu75;
            }else if(i==75){
                imgsrc = futu76;
            }else if(i==76){
                imgsrc = futu77;
            }else if(i==77){
                imgsrc = futu78;
            }else if(i==78){
                imgsrc = futu79;
            }else if(i==79){
                imgsrc = futu80;
            }else if(i==80){
                imgsrc = futu81;
            }else if(i==81){
                imgsrc = futu82;
            }else if(i==82){
                imgsrc = futu83;
            }else if(i==83){
                imgsrc = futu84;
            }else if(i==84){
                imgsrc = futu85;
            }else if(i==85){
                imgsrc = futu86;
            }else if(i==86){
                imgsrc = futu87;
            }else if(i==87){
                imgsrc = futu88;
            }else if(i==88){
                imgsrc = futu89;
            }else if(i==89){
                imgsrc = futu90;
            }else if(i==90){
                imgsrc = futu91;
            }else if(i==91){
                imgsrc = futu92;
            }else if(i==92){
                imgsrc = futu93;
            }else if(i==93){
                imgsrc = futu94;
            }else if(i==94){
                imgsrc = futu95;
            }else if(i==95){
                imgsrc = futu96;
            }else if(i==96){
                imgsrc = futu97;
            }else if(i==97){
                imgsrc = futu98;
            }else if(i==98){
                imgsrc = futu99;
            }else if(i==99){
                imgsrc = futu100;
            }
            //
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
            let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
            //
            let _skuId = _shangjia_variants_skus[i]['subsku'];
            _skuId = 'S'+_skuId;
            //

            //
            let export_data_item = {
                'Handle': _Handle,
                'Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'Body (HTML)': i==0?_body_html:'',
                'Vendor': i==0?'mysite':'',
                'Type':'',
                'Tags':'',
                'Published':i==0?'TRUE':'',
                'Option1 Name': specs_key1_name?specs_key1_name:specs_key2_name,
                'Option1 Value': specs_key1_name?_shangjia_variants_skus[i]['specs_key1_value']:_shangjia_variants_skus[i]['specs_key2_value'],
                'Option2 Name': specs_key1_name?specs_key2_name:'',
                'Option2 Value': specs_key1_name?_shangjia_variants_skus[i]['specs_key2_value']:'',
                'Option3 Name': specs_key3_name,
                'Option3 Value': _shangjia_variants_skus[i]['specs_key3_value'],
                'Variant SKU': _skuId,
                'Variant Grams': 0,
                'Variant Inventory Tracker':'shopify',
                'Variant Inventory Qty': _shangjia_variants_skus[i]['stockQuantity'],
                'Variant Inventory Policy':'continue',
                'Variant Fulfillment Service':'manual',
                'Variant Price':_shangjia_variants_skus[i]['normalPriceStr'].replace('$',''),
                'Variant Compare At Price':_shangjia_variants_skus[i]['normalPriceStr'].replace('$',''),
                'Variant Requires Shipping':'TRUE',
                'Variant Taxable':'TRUE',
                'Variant Barcode':'',
                'Image Src': imgsrc,
                'Image Position': imgsrc?(i+1):'',
                'Image Alt Text':'',
                'Gift Card': i==0?'FALSE':'',
                'SEO Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'SEO Description': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'Google Shopping / Google Product Category':'',
                'Google Shopping / Gender':'',
                'Google Shopping / Age Group':'',
                'Google Shopping / MPN':'',
                'Google Shopping / AdWords Grouping':'',
                'Google Shopping / AdWords Labels':'',
                'Google Shopping / Condition':'',
                'Google Shopping / Custom Product':'',
                'Google Shopping / Custom Label 0':'',
                'Google Shopping / Custom Label 1':'',
                'Google Shopping / Custom Label 2':'',
                'Google Shopping / Custom Label 3':'',
                'Google Shopping / Custom Label 4':'',
                'Variant Image': _shangjia_variants_skus[i]['img'],
                'Variant Weight Unit':'',
                'Variant Tax Code':'',
                'Cost per item':'',
                'Status':i==0?'active':''
            }
            export_datas.push(export_data_item);
            //
        }
        //
        if(_shangjia_gallery_arr.length > _shangjia_variants_skus.length){
            //
            for(let _g=_shangjia_variants_skus.length;_g<_shangjia_gallery_arr.length;_g++){
                let export_data_item = {
                    'Handle': _Handle,
                    'Title': '',
                    'Body (HTML)': '',
                    'Vendor': '',
                    'Type':'',
                    'Tags':'',
                    'Published':'',
                    'Option1 Name': '',
                    'Option1 Value': '',
                    'Option2 Name': '',
                    'Option2 Value': '',
                    'Option3 Name': '',
                    'Option3 Value': '',
                    'Variant SKU': '',
                    'Variant Grams': '',
                    'Variant Inventory Tracker':'',
                    'Variant Inventory Qty': '',
                    'Variant Inventory Policy':'',
                    'Variant Fulfillment Service':'',
                    'Variant Price':'',
                    'Variant Compare At Price':'',
                    'Variant Requires Shipping':'',
                    'Variant Taxable':'',
                    'Variant Barcode':'',
                    'Image Src': _shangjia_gallery_arr[_g],
                    'Image Position': (_g+1),
                    'Image Alt Text':'',
                    'Gift Card': '',
                    'SEO Title': '',
                    'SEO Description': '',
                    'Google Shopping / Google Product Category':'',
                    'Google Shopping / Gender':'',
                    'Google Shopping / Age Group':'',
                    'Google Shopping / MPN':'',
                    'Google Shopping / AdWords Grouping':'',
                    'Google Shopping / AdWords Labels':'',
                    'Google Shopping / Condition':'',
                    'Google Shopping / Custom Product':'',
                    'Google Shopping / Custom Label 0':'',
                    'Google Shopping / Custom Label 1':'',
                    'Google Shopping / Custom Label 2':'',
                    'Google Shopping / Custom Label 3':'',
                    'Google Shopping / Custom Label 4':'',
                    'Variant Image': '',
                    'Variant Weight Unit':'',
                    'Variant Tax Code':'',
                    'Cost per item':'',
                    'Status':''
                }
                export_datas.push(export_data_item);
            }
        }
        exportToCsv(export_datas, 'gycharm-amazon-shopify-export-'+_shangjia_goodsId, "Sheet1");
    }
}

function export_tiktok_xlsx_output(need_item, pingtai){
    let export_datas = [];
    let shangjia_about_contact_and_basic_info = need_item;
    let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
    //
    let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
    //
    let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

    let futu1 = '';
    let futu2 = '';
    let futu3 = '';
    let futu4 = '';
    let futu5 = '';

    let futu6 = '';
    let futu7 = '';
    let futu8 = '';
    let futu9 = '';
    let futu10 = '';

    let futu11 = '';
    let futu12 = '';
    let futu13 = '';
    let futu14 = '';
    let futu15 = '';

    let futu16 = '';
    let futu17 = '';
    let futu18 = '';
    let futu19 = '';
    let futu20 = '';

    if(_shangjia_gallery_arr.length>=1){
        futu1 = _shangjia_gallery_arr[0];
    }
    if(_shangjia_gallery_arr.length>=2){
        futu2 = _shangjia_gallery_arr[1];
    }
    if(_shangjia_gallery_arr.length>=3){
        futu3 = _shangjia_gallery_arr[2];
    }
    if(_shangjia_gallery_arr.length>=4){
        futu4 = _shangjia_gallery_arr[3];
    }
    if(_shangjia_gallery_arr.length>=5){
        futu5 = _shangjia_gallery_arr[4];
    }
    if(_shangjia_gallery_arr.length>=6){
        futu6 = _shangjia_gallery_arr[5];
    }
    if(_shangjia_gallery_arr.length>=7){
        futu7 = _shangjia_gallery_arr[6];
    }
    if(_shangjia_gallery_arr.length>=8){
        futu8 = _shangjia_gallery_arr[7];
    }
    if(_shangjia_gallery_arr.length>=9){
        futu9 = _shangjia_gallery_arr[8];
    }
    if(_shangjia_gallery_arr.length>=10){
        futu10 = _shangjia_gallery_arr[9];
    }
    if(_shangjia_gallery_arr.length>=11){
        futu11 = _shangjia_gallery_arr[10];
    }
    if(_shangjia_gallery_arr.length>=12){
        futu12 = _shangjia_gallery_arr[11];
    }
    if(_shangjia_gallery_arr.length>=13){
        futu13 = _shangjia_gallery_arr[12];
    }
    if(_shangjia_gallery_arr.length>=14){
        futu14 = _shangjia_gallery_arr[13];
    }
    if(_shangjia_gallery_arr.length>=15){
        futu15 = _shangjia_gallery_arr[14];
    }
    if(_shangjia_gallery_arr.length>=16){
        futu16 = _shangjia_gallery_arr[15];
    }
    if(_shangjia_gallery_arr.length>=17){
        futu17 = _shangjia_gallery_arr[16];
    }
    if(_shangjia_gallery_arr.length>=18){
        futu18 = _shangjia_gallery_arr[17];
    }
    if(_shangjia_gallery_arr.length>=19){
        futu19 = _shangjia_gallery_arr[18];
    }
    if(_shangjia_gallery_arr.length>=20){
        futu20 = _shangjia_gallery_arr[19];
    }
    //
    let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
    //
    let _body_html = shangjia_about_contact_and_basic_info['_shangjia_desc'];
    if(pingtai == 'tiktok2'){
        _body_html = shangjia_about_contact_and_basic_info['_product_about_this_item'];
    }
    //
    for(let i=0;i<_shangjia_variants_skus.length;i++){
        //
        let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
        let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
        let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
        let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
        //
        let _skuId = _shangjia_variants_skus[i]['subsku'];
        _skuId = 'T'+_skuId;
        //
        let _category_str = '';

        let export_data_item = {
            'Category': _category_str,
            'Brand':'',
            'Product Name': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
            'Product Description': _body_html,
            'Package Weight(lb)':'',
            'Package Length(inch)':'',
            'Package Width(inch)':'',
            'Package Height(inch)':'',
            'Delivery options':'Default',
            'Identifier Code Type':'',
            'Identifier Code':'',
            '属性1名': specs_key1_name,
            'Variation 1': _shangjia_variants_skus[i]['specs_key1_value'],
            '属性图片': _shangjia_variants_skus[i]['color_image'],
            '属性2名': specs_key2_name,
            'Variation 2': _shangjia_variants_skus[i]['specs_key2_value'],
            '属性3名': specs_key3_name,
            'Variation 3': _shangjia_variants_skus[i]['specs_key3_value'],
            '属性4名': specs_key4_name,
            'Variation 4': _shangjia_variants_skus[i]['specs_key4_value'],
            'Variant Image': _shangjia_variants_skus[i]['img'],
            'Retail Price (Local Currency)': _shangjia_variants_skus[i]['normalPriceStr'],
            'Quantity in RUIZ SPORT STORE': _shangjia_variants_skus[i]['stockQuantity'],
            'Seller SKU': _skuId,
            'Main Product Image': _shangjia_variants_skus[i]['img'],
            'Product Image 2': futu1,
            'Product Image 3': futu2,
            'Product Image 4': futu3,
            'Product Image 5': futu4,
            'Product Image 6': futu5,
            'Product Image 7': futu6,
            'Product Image 8': futu7,
            'Product Image 9': futu8,
            'Product Image 10': futu9,
            'Product Image 11': futu10,
            'Product Image 12': futu11,
            'Product Image 13': futu12,
            'Product Image 14': futu13,
            'Product Image 15': futu14,
            'Product Image 16': futu15,
            'Product Image 17': futu16,
            'Product Image 18': futu17,
            'Product Image 19': futu18,
            'Product Image 20': futu19,
            'Product Image 21': futu20,
            'Size Chart':'',
            'Product Status':'',
        }
        export_datas.push(export_data_item);
        //
    }
    //
    exportToExcel(export_datas, 'gycharm-amazon-tiktok-export-'+Date.now(), "Sheet1");
    //
}

function export_shein_xlsx_output(need_item){
    let export_datas = [];
    //
    if (true) {
        let shangjia_about_contact_and_basic_info = need_item;
        let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
        let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
        let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

        let futu1 = '';
        let futu2 = '';
        let futu3 = '';
        let futu4 = '';
        let futu5 = '';

        let futu6 = '';
        let futu7 = '';
        let futu8 = '';
        let futu9 = '';
        let futu10 = '';

        let futu11 = '';
        let futu12 = '';
        let futu13 = '';
        let futu14 = '';
        let futu15 = '';

        let futu16 = '';
        let futu17 = '';
        let futu18 = '';
        let futu19 = '';
        let futu20 = '';

        if(_shangjia_gallery_arr.length>=1){
            futu1 = _shangjia_gallery_arr[0];
        }
        if(_shangjia_gallery_arr.length>=2){
            futu2 = _shangjia_gallery_arr[1];
        }
        if(_shangjia_gallery_arr.length>=3){
            futu3 = _shangjia_gallery_arr[2];
        }
        if(_shangjia_gallery_arr.length>=4){
            futu4 = _shangjia_gallery_arr[3];
        }
        if(_shangjia_gallery_arr.length>=5){
            futu5 = _shangjia_gallery_arr[4];
        }
        if(_shangjia_gallery_arr.length>=6){
            futu6 = _shangjia_gallery_arr[5];
        }
        if(_shangjia_gallery_arr.length>=7){
            futu7 = _shangjia_gallery_arr[6];
        }
        if(_shangjia_gallery_arr.length>=8){
            futu8 = _shangjia_gallery_arr[7];
        }
        if(_shangjia_gallery_arr.length>=9){
            futu9 = _shangjia_gallery_arr[8];
        }
        if(_shangjia_gallery_arr.length>=10){
            futu10 = _shangjia_gallery_arr[9];
        }
        if(_shangjia_gallery_arr.length>=11){
            futu11 = _shangjia_gallery_arr[10];
        }
        if(_shangjia_gallery_arr.length>=12){
            futu12 = _shangjia_gallery_arr[11];
        }
        if(_shangjia_gallery_arr.length>=13){
            futu13 = _shangjia_gallery_arr[12];
        }
        if(_shangjia_gallery_arr.length>=14){
            futu14 = _shangjia_gallery_arr[13];
        }
        if(_shangjia_gallery_arr.length>=15){
            futu15 = _shangjia_gallery_arr[14];
        }
        if(_shangjia_gallery_arr.length>=16){
            futu16 = _shangjia_gallery_arr[15];
        }
        if(_shangjia_gallery_arr.length>=17){
            futu17 = _shangjia_gallery_arr[16];
        }
        if(_shangjia_gallery_arr.length>=18){
            futu18 = _shangjia_gallery_arr[17];
        }
        if(_shangjia_gallery_arr.length>=19){
            futu19 = _shangjia_gallery_arr[18];
        }
        if(_shangjia_gallery_arr.length>=20){
            futu20 = _shangjia_gallery_arr[19];
        }
        //
        let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
        //
        /*let _shangjia_product_link = '';
        let _shangjia_a_link = window.location.href;
        if(_shangjia_a_link.indexOf('?')!=-1){
            let _shangjia_a_link_arr = _shangjia_a_link.split('?');
            _shangjia_product_link = _shangjia_a_link_arr[0];
            let _shangjia_a_link_args = _shangjia_a_link_arr[1];
            let _shangjia_a_link_args_arr = _shangjia_a_link_args.split('&');
            let _gid_arg = _shangjia_a_link_args_arr[0];
            _shangjia_product_link +='?'+_gid_arg;
        }*/
        let _main_img = shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'];
        let _shangjia_VideoUrl = shangjia_about_contact_and_basic_info['_shangjia_VideoUrl'];
        //
        for(let i=0;i<_shangjia_variants_skus.length;i++){
            //
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
            let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
            //
            if(_shangjia_variants_skus[i]['img']){
                _main_img = _shangjia_variants_skus[i]['img'];
            }
            if(_shangjia_variants_skus[i]['gallery_imgs']){
                let gallery_imgs = _shangjia_variants_skus[i]['gallery_imgs'];
                console.log('gallery_imgs');
                console.log(gallery_imgs);
                if(gallery_imgs.length>=2){
                    futu1 = gallery_imgs[1];
                }
                if(gallery_imgs.length>=3){
                    futu2 = gallery_imgs[2];
                }
                if(gallery_imgs.length>=4){
                    futu3 = gallery_imgs[3];
                }
                if(gallery_imgs.length>=5){
                    futu4 = gallery_imgs[4];
                }
                if(gallery_imgs.length>=6){
                    futu5 = gallery_imgs[5];
                }
                if(gallery_imgs.length>=7){
                    futu6 = gallery_imgs[6];
                }
                if(gallery_imgs.length>=8){
                    futu7 = gallery_imgs[7];
                }
                if(gallery_imgs.length>=9){
                    futu8 = gallery_imgs[8];
                }
                if(gallery_imgs.length>=10){
                    futu9 = gallery_imgs[9];
                }
                if(gallery_imgs.length>=11){
                    futu10 = gallery_imgs[10];
                }
                if(gallery_imgs.length>=12){
                    futu11 = gallery_imgs[11];
                }
                if(gallery_imgs.length>=13){
                    futu12 = gallery_imgs[12];
                }
                if(gallery_imgs.length>=14){
                    futu13 = gallery_imgs[13];
                }
                if(gallery_imgs.length>=15){
                    futu14 = gallery_imgs[14];
                }
                if(gallery_imgs.length>=16){
                    futu15 = gallery_imgs[15];
                }
                if(gallery_imgs.length>=17){
                    futu16 = gallery_imgs[16];
                }
                if(gallery_imgs.length>=18){
                    futu17 = gallery_imgs[17];
                }
                if(gallery_imgs.length>=19){
                    futu18 = gallery_imgs[18];
                }
                if(gallery_imgs.length>=20){
                    futu19 = gallery_imgs[19];
                }
                if(gallery_imgs.length>=21){
                    futu20 = gallery_imgs[20];
                }
            }
            if(_shangjia_variants_skus[i]['video_url']){
                _shangjia_VideoUrl = _shangjia_variants_skus[i]['video_url'];
            }
            //
            let export_data_item = {
                '产品url': shangjia_about_contact_and_basic_info['_product_url'],
                'SKU': shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
                //'原变体SKU': _shangjia_variants_skus[i]['skuId'],
                '变体带属性SKU': _shangjia_variants_skus[i]['subsku'],
                '产品标题': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                //'Category': shangjia_about_contact_and_basic_info['_shangjia_category'],
                '变体图片': _main_img,
                '价格': _shangjia_variants_skus[i]['normalPriceStr'],
                '原价': _shangjia_variants_skus[i]['normalLinePriceStr'],
                '变体库存': _shangjia_variants_skus[i]['stockQuantity'],
                '属性1名': specs_key1_name,
                '属性1值': _shangjia_variants_skus[i]['specs_key1_value'],
                '属性图片': _shangjia_variants_skus[i]['color_image'],
                '属性2名': specs_key2_name,
                '属性2值': _shangjia_variants_skus[i]['specs_key2_value'],
                '属性图片': _shangjia_variants_skus[i]['color_image'],
                //'属性3名': specs_key3_name,
                //'属性3值': _shangjia_variants_skus[i]['specs_key3_value'],
                //'属性4名': specs_key4_name,
                //'属性4值': _shangjia_variants_skus[i]['specs_key4_value'],
                '主图': _main_img,
                '附图1': futu1,
                '附图2': futu2,
                '附图3': futu3,
                '附图4': futu4,
                '附图5': futu5,
                '附图6': futu6,
                '附图7': futu7,
                '附图8': futu8,
                '附图9': futu9,
                '附图10': futu10,
                '附图11': futu11,
                '附图12': futu12,
                '附图13': futu13,
                '附图14': futu14,
                '附图15': futu15,
                '附图16': futu16,
                '附图17': futu17,
                '附图18': futu18,
                '附图19': futu19,
                '附图20': futu20,
                'VideoUrl': _shangjia_VideoUrl,
                //'产品属性': shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'],
                '产品描述': shangjia_about_contact_and_basic_info['_shangjia_desc'],
                'Size & Fit': shangjia_about_contact_and_basic_info['_product_intro__sizeguide'],
                //'描述图片': shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'].join(','),
                //review
                'review': shangjia_about_contact_and_basic_info['_shangjia_reivew_num'],
                //'sold': _shangjia_sold,
                //
                //'is request': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '已完成':'未',
            }
            export_datas.push(export_data_item);
            //
        }
        console.log('export_datas');
        console.log(export_datas);
        exportToExcel(export_datas, 'gycharm-amazon-normal-export-'+_shangjia_goodsId, "Sheet1");
    }
}

function export_wordpress_csv_output(need_item, pingtai){
    console.log('export_wordpress_csv_output');
    let export_datas = [];
    let shangjia_about_contact_and_basic_info = need_item;
    //
    let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
    //
    let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

    //
    let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
    //
    let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
    //
    let good_url = window.location.href;
    good_url = good_url.trim();
    if(good_url.indexOf('?')!=-1){
        let good_url_arr = good_url.split('?');
        good_url = good_url_arr[0];
    }
    //
    let _body_html = shangjia_about_contact_and_basic_info['_shangjia_desc'];
    if(pingtai == 'wordpress2'){
        _body_html = shangjia_about_contact_and_basic_info['_product_about_this_item'];
    }
    //
    let has_variants = false;
    if(_shangjia_variants_skus.length > 0){
        //变体
        let specs_key1_values = [];
        let specs_key2_values = [];
        for(let i=0;i<_shangjia_variants_skus.length;i++){
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            if(specs_key1_name.length >0){
                if(specs_key1_values.indexOf(_shangjia_variants_skus[i]['specs_key1_value']) === -1){
                    specs_key1_values.push(_shangjia_variants_skus[i]['specs_key1_value']);
                }
            }
            if(specs_key2_name.length >0){
                if(specs_key2_values.indexOf(_shangjia_variants_skus[i]['specs_key2_value']) === -1){
                    specs_key2_values.push(_shangjia_variants_skus[i]['specs_key2_value']);
                }
            }
        }
        if(specs_key1_values.length > 0 || specs_key2_values.length >0){
            has_variants = true;
        }
    }
    //
    if(_shangjia_variants_skus.length > 0 && has_variants){
        //变体
        let specs_key1_values = [];
        let specs_key2_values = [];
        for(let i=0;i<_shangjia_variants_skus.length;i++){
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            if(specs_key1_name.length >0){
                if(specs_key1_values.indexOf(_shangjia_variants_skus[i]['specs_key1_value']) === -1){
                    specs_key1_values.push(_shangjia_variants_skus[i]['specs_key1_value']);
                }
            }
            if(specs_key2_name.length >0){
                if(specs_key2_values.indexOf(_shangjia_variants_skus[i]['specs_key2_value']) === -1){
                    specs_key2_values.push(_shangjia_variants_skus[i]['specs_key2_value']);
                }
            }
        }
        //
        for(let i=0;i<_shangjia_variants_skus.length;i++){
            //
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
            let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
            //
            let normalLinePriceStr = '';
            if(_shangjia_variants_skus[i].hasOwnProperty('normalLinePriceStr')){
                normalLinePriceStr = _shangjia_variants_skus[i]['normalLinePriceStr'];
            }
            //
            if(i == 0){
                let export_data_item = {
                    'Type':'variable', //主:variable,子:variation
                    'SKU':shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
                    'Name':shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                    'Published':1,
                    'Is featured?':0,
                    'Visibility in catalog':'visible',
                    'Short description':'',
                    'Description':_body_html,
                    'Date sale price starts':'',
                    'Date sale price ends':'',
                    'Tax status':'taxable',
                    'Tax class':'',
                    'In stock?':1,
                    'Stock':'',
                    'Backorders allowed?':0,
                    'Sold individually?':0,
                    'Weight (lbs)':'',
                    'Length (in)':'',
                    'Width (in)':'',
                    'Height (in)':'',
                    'Allow customer reviews?':1,
                    'Purchase note':'',
                    'Sale price':'', //促销价 主留空 子加
                    'Regular price':'', //正常价格 主留空 子加
                    'Categories':shangjia_about_contact_and_basic_info['_shangjia_category'],
                    'Tags':'',
                    'Shipping class':'',
                    'Images': _shangjia_gallery_arr.join(', '), //主逗号分割，子有的话 单个产品图即可
                    'Download limit':'',
                    'Download expiry days':'',
                    'Parent':'',//ID:值 或者 SKU
                    'Grouped products':'',
                    'Upsells':'',
                    'Cross-sells':'',
                    'External URL':'',
                    'Button text':'',
                    'Position':0, //默认0即可
                    'Attribute 1 name':specs_key1_name, //
                    'Attribute 1 value(s)':specs_key1_values.join(', '), //主的话 值逗号分割
                    'Attribute 1 visible':1,//只设置主，子不设置
                    'Attribute 1 global':1,//全部为1
                    'Attribute 2 name':specs_key2_name,
                    'Attribute 2 value(s)':specs_key2_values.join(', '),
                    'Attribute 2 visible':1,//只设置主，子不设置
                    'Attribute 2 global':1,//全部为1
                    'Meta:_wpcom_is_markdown': 1, //只设置主，子不设置
                    'Download 1 name':'',
                    'Download 1 URL':'',
                    'Download 2 name':'',
                    'Download 2 URL':'',
                    '元数据：_woosea_exclude_product':'no', //主需要 子不需要
                    '元数据：_wc_gla_brand':'other', //主需要 子不需要
                    '元数据：_wc_gla_visibility':'sync-and-show', //主需要 子不需要
                    '元数据：_wc_gla_sync_status':'synced',//主 子
                    '元数据：_wc_gla_synced_at':'', //留空
                    '元数据：_wc_gla_mc_status':'partially_approved',//主 子
                    '元数据：_wc_gla_gtin':'', //主空 子填
                    '元数据：_wc_gla_condition':'',//主空 子 new
                    '元数据：_wc_gla_gender':'', //空
                    '元数据：_wc_gla_size':'', //主空 子填 属性值
                    '元数据：_wc_gla_sizeSystem':'', //主空 子填 US
                    '元数据：_wc_gla_sizeType':'', //主空 子 regular
                    '元数据：_wc_gla_color':'', //主空 子填 属性值
                    '元数据：_wc_gla_material':'', //空
                    '元数据：_wc_gla_pattern':'', //空
                    '元数据：_wc_gla_ageGroup':'',//空
                    '元数据：_wc_gla_multipack':'',//空
                }
                export_datas.push(export_data_item);
            }
            if(1){
                //
                let normalPriceStr = _shangjia_variants_skus[i]['normalPriceStr'];
                let normalLinePriceStr =  _shangjia_variants_skus[i]['normalLinePriceStr'];
                if(normalLinePriceStr == ''){
                    normalLinePriceStr = normalPriceStr;
                    normalPriceStr = '';
                }
                let _img = _shangjia_variants_skus[i]['img'];
                if(_img === null){
                    //循环同值 可能的图片
                    for(let j=0;i<_shangjia_variants_skus.length;j++){
                        if(_shangjia_variants_skus[i]['specs_key1_value'] == _shangjia_variants_skus[j]['specs_key1_value'] && _shangjia_variants_skus[j]['img']!==null){
                            _img =  _shangjia_variants_skus[j]['img'];
                            break;
                        }
                    }
                    //
                }
                //
                let export_data_item = {
                    'Type':'variation', //主:variable,子:variation
                    'SKU':_shangjia_variants_skus[i]['subsku'],
                    'Name':shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                    'Published':1,
                    'Is featured?':0,
                    'Visibility in catalog':'visible',
                    'Short description':'',
                    'Description':'',
                    'Date sale price starts':'',
                    'Date sale price ends':'',
                    'Tax status':'taxable',
                    'Tax class':'',
                    'In stock?':1,
                    'Stock':'',
                    'Backorders allowed?':0,
                    'Sold individually?':0,
                    'Weight (lbs)':'',
                    'Length (in)':'',
                    'Width (in)':'',
                    'Height (in)':'',
                    'Allow customer reviews?':1,
                    'Purchase note':'',
                    'Sale price':normalPriceStr, //促销价 主留空 子加
                    'Regular price':normalLinePriceStr, //正常价格 主留空 子加
                    'Categories':'',
                    'Tags':'',
                    'Shipping class':'',
                    'Images': _img, //主逗号分割，子有的话 单个产品图即可
                    'Download limit':'',
                    'Download expiry days':'',
                    'Parent':shangjia_about_contact_and_basic_info['_shangjia_goodsId'],//ID:值 或者 SKU
                    'Grouped products':'',
                    'Upsells':'',
                    'Cross-sells':'',
                    'External URL':'',
                    'Button text':'',
                    'Position':0, //默认0即可
                    'Attribute 1 name':specs_key1_name, //
                    'Attribute 1 value(s)':_shangjia_variants_skus[i]['specs_key1_value'], //主的话 值逗号分割
                    'Attribute 1 visible':'',//只设置主，子不设置
                    'Attribute 1 global':1,//全部为1
                    'Attribute 2 name':specs_key2_name,
                    'Attribute 2 value(s)':_shangjia_variants_skus[i]['specs_key2_value'],
                    'Attribute 2 visible':'',//只设置主，子不设置
                    'Attribute 2 global':1,//全部为1
                    'Meta:_wpcom_is_markdown': '', //只设置主，子不设置
                    'Download 1 name':'',
                    'Download 1 URL':'',
                    'Download 2 name':'',
                    'Download 2 URL':'',
                    '元数据：_woosea_exclude_product':'', //主需要 子不需要
                    '元数据：_wc_gla_brand':'', //主需要 子不需要
                    '元数据：_wc_gla_visibility':'', //主需要 子不需要
                    '元数据：_wc_gla_sync_status':'synced',//主 子
                    '元数据：_wc_gla_synced_at':'', //留空
                    '元数据：_wc_gla_mc_status':'partially_approved',//主 子
                    //'元数据：_wc_gla_gtin':_shangjia_variants_skus[i]['skuId'], //主空 子填
                    '元数据：_wc_gla_gtin':'', //主空 子填
                    '元数据：_wc_gla_condition':'new',//主空 子 new
                    '元数据：_wc_gla_gender':'', //空
                    '元数据：_wc_gla_size':_shangjia_variants_skus[i]['specs_key2_value'], //主空 子填 属性值
                    '元数据：_wc_gla_sizeSystem':'', //主空 子填 US
                    '元数据：_wc_gla_sizeType':'', //主空 子 regular
                    '元数据：_wc_gla_color':_shangjia_variants_skus[i]['specs_key1_value'], //主空 子填 属性值
                    '元数据：_wc_gla_material':'',
                    '元数据：_wc_gla_pattern':'', //空
                    '元数据：_wc_gla_ageGroup':'',//空
                    '元数据：_wc_gla_multipack':''//空
                }
                export_datas.push(export_data_item);
               //
            }
            //
        }
    }else{
        //简单产品
        let _shangjia_minOnSalePriceStr = shangjia_about_contact_and_basic_info['_shangjia_minOnSalePriceStr'];
        let _shangjia_normalLinePriceStr = shangjia_about_contact_and_basic_info['_shangjia_normalLinePriceStr'];
        if(_shangjia_normalLinePriceStr == ''){
            _shangjia_normalLinePriceStr = _shangjia_minOnSalePriceStr;
            _shangjia_minOnSalePriceStr = '';
        }
        //
        let export_data_item = {
                    'Type':'simple', //simple
                    'SKU':shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
                    'Name':shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                    'Published':1,
                    'Is featured?':0,
                    'Visibility in catalog':'visible',
                    'Short description':'',
                    'Description':_body_html,
                    'Date sale price starts':'',
                    'Date sale price ends':'',
                    'Tax status':'taxable',
                    'Tax class':'',
                    'In stock?':1,
                    'Stock':'',
                    'Backorders allowed?':0,
                    'Sold individually?':0,
                    'Weight (lbs)':'',
                    'Length (in)':'',
                    'Width (in)':'',
                    'Height (in)':'',
                    'Allow customer reviews?':1,
                    'Purchase note':'',
                    'Sale price':_shangjia_minOnSalePriceStr, //促销价 主留空 子加
                    'Regular price':_shangjia_normalLinePriceStr, //正常价格 主留空 子加
                    'Categories':shangjia_about_contact_and_basic_info['_shangjia_category'],
                    'Tags':'',
                    'Shipping class':'',
                    'Images': _shangjia_gallery_arr.join(', '), //主逗号分割，子有的话 单个产品图即可
                    'Download limit':'',
                    'Download expiry days':'',
                    'Parent':'',//ID:值 或者 SKU
                    'Grouped products':'',
                    'Upsells':'',
                    'Cross-sells':'',
                    'External URL':'',
                    'Button text':'',
                    'Position':0, //默认0即可
                    'Attribute 1 name':'', //
                    'Attribute 1 value(s)':'', //主的话 值逗号分割
                    'Attribute 1 visible':'',//只设置主，子不设置
                    'Attribute 1 global':'',//全部为1
                    'Attribute 2 name':'',
                    'Attribute 2 value(s)':'',
                    'Attribute 2 visible':'',//只设置主，子不设置
                    'Attribute 2 global':'',//全部为1
                    'Meta:_wpcom_is_markdown': 1, //只设置主，子不设置
                    'Download 1 name':'',
                    'Download 1 URL':'',
                    'Download 2 name':'',
                    'Download 2 URL':'',
                    '元数据：_woosea_exclude_product':'no', //主需要 子不需要
                    '元数据：_wc_gla_brand':'other', //主需要 子不需要
                    '元数据：_wc_gla_visibility':'sync-and-show', //主需要 子不需要
                    '元数据：_wc_gla_sync_status':'synced',//主 子
                    '元数据：_wc_gla_synced_at':'', //留空
                    '元数据：_wc_gla_mc_status':'partially_approved',//主 子
                    '元数据：_wc_gla_gtin':'', //主空 子填
                    '元数据：_wc_gla_condition':'',//主空 子 new
                    '元数据：_wc_gla_gender':'', //空
                    '元数据：_wc_gla_size':'', //主空 子填 属性值
                    '元数据：_wc_gla_sizeSystem':'', //主空 子填 US
                    '元数据：_wc_gla_sizeType':'', //主空 子 regular
                    '元数据：_wc_gla_color':'', //主空 子填 属性值
                    '元数据：_wc_gla_material':'',
                    '元数据：_wc_gla_pattern':'', //空
                    '元数据：_wc_gla_ageGroup':'',//空
                    '元数据：_wc_gla_multipack':''//空
                }
        export_datas.push(export_data_item);
        //
    }
    //
    console.log('export_datas');
    console.log(export_datas);
    exportToCsv(export_datas, 'gycharm-amazon-wordpress-export-'+shangjia_about_contact_and_basic_info['_shangjia_goodsId'], "Sheet1");
    //
}

function export_single(pingtai='shopify') {
    //
    let message = {
        action: 'check_expire'
    };
    chrome.runtime.sendMessage(message,(msg)=> {
        console.log('check_expire 答复', msg)
        let msgobj = JSON.parse(msg);
        console.log(msgobj['state']);
        let state = parseInt(msgobj['state']);
        if (state == 0) {//未过期
            //
            let data = $('html').html();
            let _dom = $(data);
            //
            let _shangjia_goodsName = $('#productTitle').text();
            if(_shangjia_goodsName){
               //
                let shangjia_info = {};
                let current_url = window.location.href;
                let _shangjia_goodsId = util_getasin(current_url);
                let current_domain = util_get_current_webiste_domain(current_url);
                shangjia_info['_shangjia_goodsId'] = _shangjia_goodsId;
                //
                shangjia_info['_product_url'] = current_url;
                //
                _shangjia_goodsName = _shangjia_goodsName.trim();
                shangjia_info['_shangjia_goodsName'] = _shangjia_goodsName;
                //
                let _product_price = $('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
                let _product_old_price = $('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
                if(_product_price){
                    _product_price = _product_price.trim();
                    _product_price = _product_price.replace('$','');
                }
                if(_product_old_price){
                    _product_old_price = _product_old_price.trim();
                    _product_old_price = _product_old_price.replace('$','');
                }
                shangjia_info['_shangjia_minOnSalePriceStr'] = _product_price;
                shangjia_info['_shangjia_minOriginPriceStr'] = _product_old_price;
                //
                let  _product_intro__sizeguide = $('#fit-sizechartv2-0').html();
                if(typeof _product_intro__sizeguide == 'undefined'){
                    _product_intro__sizeguide = '';
                }else{
                    _product_intro__sizeguide = "<div class='product-intro__sizeguide'>"+_product_intro__sizeguide+"</div>";
                }
                shangjia_info['_product_intro__sizeguide'] = _product_intro__sizeguide;
                //
                let _product_about_this_item = $("#productFactsDesktopExpander .a-expander-content").html();
                if(typeof _product_about_this_item == 'undefined' || _product_about_this_item==''){
                    _product_about_this_item = $('#feature-bullets').html();
                    if(typeof _product_about_this_item == 'undefined'){
                        _product_about_this_item = '';
                    }
                }
                if(_product_about_this_item){
                    _product_about_this_item = _product_about_this_item.replace('<hr>','');
                    _product_about_this_item = _product_about_this_item.trim();
                    _product_about_this_item = _product_about_this_item.replace(/<a\b[^>]*>(.*?)<\/a>/gi, '');
                }
                shangjia_info['_product_about_this_item'] = _product_about_this_item;
                //
                /*let _shangjia_desc = '';//
                let _shangjia_desc_content = '';
                let _celwidget_aplus_module_count = $('#aplus_feature_div #aplus .celwidget.aplus-module').length;
                let _camc_num = 1;
                $('#aplus_feature_div #aplus .celwidget.aplus-module').each(function (){
                    if(_camc_num < _celwidget_aplus_module_count){
                        let _celwidget_aplus_module_content = $(this).html();
                        _celwidget_aplus_module_content = _celwidget_aplus_module_content.replace(/<style\b[^>]*>[\s\S]*?<\/style>/gi, '');
                        _celwidget_aplus_module_content = _celwidget_aplus_module_content.replace(/<script\b[^>]*>[\s\S]*?<\/script>/gi, '');
                        if((_shangjia_desc_content.length + _celwidget_aplus_module_content.length) < 32000 ){
                            _shangjia_desc_content += "<div class='celwidget aplus-module 3p-module-b aplus-standard'>"+_celwidget_aplus_module_content+"</div>";
                        }
                    }
                    _camc_num++;
                });
                if(_shangjia_desc_content){
                    _shangjia_desc = "<div class='product-intro__description'><div class='product-intro__description-table'>"+_shangjia_desc_content+"</div></div>";
                }
                shangjia_info['_shangjia_desc'] = _shangjia_desc;*/
                //
                let _shangjia_desc = '';
                $('#aplus_feature_div #aplus .celwidget.aplus-module').each(function (){
                    $(this).find("img").each(function (){
                        let _img = $(this).attr('data-src');
                        _shangjia_desc += "<img src='"+_img+"'/>";
                    });
                });
                if(_shangjia_desc == ''){
                    _shangjia_desc = $("#productDescription").html();
                }
                _shangjia_desc = "<div class='product-intro__description'><div class='product-intro__description-table'>"+_shangjia_desc+"</div></div>";
                shangjia_info['_shangjia_desc'] = _shangjia_desc;
                //
                let _shangjia_goodsProperty = "";
                shangjia_info['_shangjia_goodsProperty'] = _shangjia_goodsProperty;
                //
                let _shangjia_gallery = util_amz_get_product_lunbo_imgs(_dom);
                let _shangjia_hdThumbUrl = _shangjia_gallery[0];
                shangjia_info['_shangjia_hdThumbUrl'] = _shangjia_hdThumbUrl;
                //
                shangjia_info['_shangjia_productDetailFlatList'] = [];
                let _shangjia_VideoUrl = util_amz_get_product_video(data);
                shangjia_info['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                //子sku
                let specs_key1_name = '';
                let specs_key2_name = '';
                specs_key1_name = $('#variation_color_name div.a-row label').text();
                if(typeof specs_key1_name != "undefined"){
                    specs_key1_name = specs_key1_name.replace(':','');
                    specs_key1_name = specs_key1_name.trim();
                }else{
                    specs_key1_name = '';
                }
                //
                specs_key2_name = $('#variation_size_name div.a-row label').text();
                if(typeof specs_key2_name == 'undefined'){
                    specs_key2_name = '';
                }else{
                    specs_key2_name = specs_key2_name.replace(':','');
                    specs_key2_name = specs_key2_name.trim();
                }
                console.log('specs_key2_name');
                console.log(specs_key2_name);
                //如果color存在且大于2个，则不采集
                let specs_key1_name_values_num = 0;
                $('#variation_color_name ul li').each(function (){
                    specs_key1_name_values_num +=1;
                });
                //
                $("#variation_color_name select[name='dropdown_selected_color_name'] option").each(function (){
                    specs_key1_name_values_num +=1;
                });
                //
                let _shangjia_variants_skus = [];
                if(specs_key1_name_values_num >= 1){
                    _shangjia_gallery = [];
                    let _size_arr = [];
                    $("#variation_size_name select[name='dropdown_selected_size_name'] option").each(function (){
                        let _option_val = $(this).val();
                        if(_option_val != '-1'){
                            let specs_key2_value = $(this).text();
                            specs_key2_value = specs_key2_value.trim();
                            _size_arr.push(specs_key2_value);
                        }
                    });
                    //ul li
                    $('#variation_size_name ul li').each(function (){
                        _size_arr.push($(this).find('p').text());
                    });
                    //
                    console.log('_size_arr');
                    console.log(_size_arr);

                    let relation_color_arr = [];
                    //ul li形式
                    $('#variation_color_name ul li').each(function (){
                        relation_color_arr.push($(this).attr('data-csa-c-item-id'));
                    });
                    //select形式
                   $("#variation_color_name select[name='dropdown_selected_color_name'] option").each(function (){
                        let _color_asin = $(this).val();
                        if(_color_asin.indexOf(',')!=-1){
                            let _color_asin_arr  = _color_asin.split(',');
                            _color_asin = _color_asin_arr[1];
                        }
                        relation_color_arr.push(_color_asin);
                    });
                    console.log('relation_color_arr');
                    console.log(relation_color_arr);
                    //
                    for(let _r=0;_r<relation_color_arr.length;_r++){
                        let _shangjia_variants_skus_cucao = shangjia_get_subskus_ajax(
                            current_domain,
                            specs_key1_name,
                            specs_key2_name,
                            relation_color_arr[_r],
                            _size_arr);
                        if(_shangjia_variants_skus_cucao){
                            for(let _c=0;_c<_shangjia_variants_skus_cucao.length;_c++){
                                //
                                if(_c==0){
                                    //同一个颜色有多个尺寸，只取第一个即可
                                    let _gallery_imgs = _shangjia_variants_skus_cucao[_c]['gallery_imgs'];
                                    for(let _g=0;_g<_gallery_imgs.length;_g++){
                                        _shangjia_gallery.push(_gallery_imgs[_g]);
                                    }
                                }
                                //
                                _shangjia_variants_skus.push(_shangjia_variants_skus_cucao[_c]);
                            }
                        }else{
                            //可能
                            console.log('util_get_json可能遇到反爬');
                            //
                        }
                    }
                    //
                }else{
                    //
                    if(specs_key2_name){ //有尺寸
                        let _shangjia_variants_skus_cucao = shangjia_get_subskus(
                            _dom,
                            shangjia_info['_shangjia_goodsId'],
                            specs_key1_name,
                            '',
                            specs_key2_name);
                        for(let _c=0;_c<_shangjia_variants_skus_cucao.length;_c++){
                            _shangjia_variants_skus.push(_shangjia_variants_skus_cucao[_c]);
                        }
                    }else{
                        //无尺寸,无属性
                        _shangjia_variants_skus.push({
                            'subsku': shangjia_info['_shangjia_goodsId'], //
                            'normalPriceStr': _product_price, //特价
                            'normalLinePriceStr': _product_old_price, //原价
                            'img':'',
                            'gallery_imgs':[],
                            'video_url':_shangjia_VideoUrl,
                            'specs_key1_name':'',
                            'specs_key1_value':'',
                            'specs_key2_name':'',
                            'specs_key2_value':'',
                            'specs_key3_name':'',
                            'specs_key3_value':'',
                            'specs_key4_name':'',
                            'specs_key4_value':'',
                            'stockQuantity': '',
                            'skuId': '' //原变体sku
                        });
                    }
                    //
                }
                //
                shangjia_info['_shangjia_variants_skus'] = _shangjia_variants_skus;
                shangjia_info['_shangjia_gallery'] = _shangjia_gallery;
                //
                shangjia_info['_shangjia_sold'] = 0;
                let _shangjia_review_num = 0;
                console.log('_shangjia_review_num');
                console.log(_shangjia_review_num);
                if(typeof _shangjia_review_num == 'undefined'){
                    _shangjia_review_num = 0;
                }else{
                    _shangjia_review_num = parseInt(_shangjia_review_num);
                }
                shangjia_info['_shangjia_reivew_num'] = _shangjia_review_num;
                console.log('shangjia_info');
                console.log(shangjia_info);
                //
                // 在新标签页中打开指定的 URL
                if(pingtai == 'shopify' || pingtai == 'shopify2'){
                    export_shopify_csv_output(shangjia_info, pingtai);
                }else if(pingtai == 'tiktok' || pingtai == 'tiktok2'){
                    export_tiktok_xlsx_output(shangjia_info, pingtai);
                }else if(pingtai == 'normal'){
                    export_normal_xlsx_output(shangjia_info);
                }else if(pingtai == 'shein'){
                    export_shein_xlsx_output(shangjia_info);
                }else if(pingtai == 'wordpress' || pingtai == 'wordpress2'){
                    export_wordpress_csv_output(shangjia_info, pingtai);
                }
                //
            }else{
                console.log('not found product name');
            }
            //
        }else{
            $('.gycharm-tips').remove();
            let gycharm_tips = $("<div>", {
                class:'gycharm-tips',
                html: '亚马逊产品采集刊登插件，还未购买或者已过期，请<a href="https://www.gycharm.com/user/order-plugin?plugin=vip_amz_product_1nian&type=other_plugin" target="_blank">Gycharm.com</a>官网购买或者续费！', // 按钮文本
                style: "display: block;\n" +
                    "    z-index: 999;\n" +
                    "    color: red;\n" +
                    "    padding-top: 20px;\n" +
                    "    margin-top: 20px;\n" +
                    "    border: 0;\n" +
                    "    line-height: 20px;\n" +
                    "    font-weight: bold;\n"
             });
            $('#leftCol').append(gycharm_tips);
        }
    });
}

//
function add_export_pingtai_btn(){
    let current_url = window.location.href;
    // 创建一个按钮元素
    if(current_url.indexOf('/dp/')!=-1){
         $('#leftCol').append("<div id='gycharm-export-tips' style='color:red;margin-top:10px;'>提示: 点击导出按钮后，需要花费1~2分钟，导出完成后会自动下载</div>");
         //
         var newNormalButton = $("<button>", {
            text: '通用Excel格式导出', // 按钮文本
            style: "display: block;\n" +
                "    top: 650px;\n" +
                "    margin-top: 10px;\n" +
                "    left:0;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    border: 0;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
                export_single('normal');
            } // 点击按钮时执行的函数
         });
         $('#leftCol').append(newNormalButton);
         //
         var newButton = $("<button>", {
            text: '导出Shopify格式(Product Description作为描述)', // 按钮文本
            style: "display: block;\n" +
                "    margin-top: 10px;\n" +
                "    top: 700px;\n" +
                "    left:0;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    border: 0;\n" +
                "    height: auto;\n" +
                "    line-height: 22px;\n" +
                 "text-align:center;\n"+
                "padding:0 10px;\n"+
                "word-wrap: break-word;\n"+
                "overflow-wrap: break-word;\n"+
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('shopify');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $('#leftCol').append(newButton);
        //
        var shopifyExport2 = $("<button>", {
            text: '导出Shopify格式(About this item作为描述)', // 按钮文本
            style: "display: block;\n" +
                "    margin-top: 10px;\n" +
                "    top: 700px;\n" +
                "    left:0;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    border: 0;\n" +
               "    height: auto;\n" +
                "    line-height: 22px;\n" +
                 "text-align:center;\n"+
                "padding:0 10px;\n"+
                "word-wrap: break-word;\n"+
                "overflow-wrap: break-word;\n"+
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('shopify2');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $('#leftCol').append(shopifyExport2);
        //
        var newTiktokButton = $("<button>", {
            text: '导出Tiktok格式(Product Description作为描述)', // 按钮文本
            style: "display: block;\n" +
                "    margin-top: 10px;\n" +
                "    top: 750px;\n" +
                "    left:0;\n" +
                "    z-index: 999;\n" +
                "    border: 0;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: auto;\n" +
                "    line-height: 22px;\n" +
                 "text-align:center;\n"+
                "padding:0 10px;\n"+
                "word-wrap: break-word;\n"+
                "overflow-wrap: break-word;\n"+
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('tiktok');
            } // 点击按钮时执行的函数
        });
        $('#leftCol').append(newTiktokButton);
        //
        //
        var newTiktokButton2 = $("<button>", {
            text: '导出Tiktok格式(About this item作为描述)', // 按钮文本
            style: "display: block;\n" +
                "    margin-top: 10px;\n" +
                "    top: 750px;\n" +
                "    left:0;\n" +
                "    z-index: 999;\n" +
                "    border: 0;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
               "    height: auto;\n" +
                "    line-height: 22px;\n" +
                 "text-align:center;\n"+
                "padding:0 10px;\n"+
                "word-wrap: break-word;\n"+
                "overflow-wrap: break-word;\n"+
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('tiktok2');
            } // 点击按钮时执行的函数
        });
        $('#leftCol').append(newTiktokButton2);
        //
        var newWordpressButton = $("<button>", {
            text: '导出Wordpress(WooCommerce)格式(Product Description作为描述)', // 按钮文本
            style: "display: block;\n" +
                "    margin-top: 10px;\n" +
                "    top: 750px;\n" +
                "    left:0;\n" +
                "    z-index: 999;\n" +
                "    border: 0;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    line-height: 22px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "text-align:center;\n"+
                "padding:0 10px;\n"+
                "word-wrap: break-word;\n"+
                "overflow-wrap: break-word;\n"+
                "    border-radius: 22px;",
            click: function() {
               export_single('wordpress');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $("#leftCol").append(newWordpressButton);
        //
        //
        var newWordpressButton2 = $("<button>", {
            text: '导出Wordpress(WooCommerce)格式(About this item作为描述)', // 按钮文本
            style: "display: block;\n" +
                "    margin-top: 10px;\n" +
                "    top: 750px;\n" +
                "    left:0;\n" +
                "    z-index: 999;\n" +
                "    border: 0;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    line-height: 22px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "text-align:center;\n"+
                "padding:0 10px;\n"+
                "word-wrap: break-word;\n"+
                "overflow-wrap: break-word;\n"+
                "    border-radius: 22px;",
            click: function() {
               export_single('wordpress2');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $("#leftCol").append(newWordpressButton2);
        //
        //
        var newSheinButton = $("<button>", {
            text: '导出Shein格式', // 按钮文本
            style: "display: block;\n" +
                "    position: absolute;\n" +
                "    top: 750px;\n" +
                "    left:0;\n" +
                "    z-index: 999;\n" +
                "    border: 0;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('shein');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
       // $('.product-intro__galleryWrap').append(newSheinButton);
    }
}

//
$(document).ready(function () {
    //
    setTimeout(function (){
         //add_product_to_plugin_Button();
         add_export_pingtai_btn();
         amz_add_download_btn();
         //shangjia_new_tab_process_item_step2();

    },2000);
    extract_shangjias();
});
//

function util_scrollToBottom(iframe, callback) {
    var iframeWindow = iframe.contentWindow;
    var start = iframeWindow.pageYOffset; // 当前滚动位置
    var end = iframeWindow.document.body.scrollHeight - iframeWindow.innerHeight; // 滚动到底部

    var duration = 8000; // 3 秒
    var startTime = null;

    function scroll(time) {
        if (!startTime) {
            startTime = time;
        }
        var progress = (time - startTime) / duration;
        if (progress > 1) {
            progress = 1;
        }
        var newPosition = start + (end - start) * progress;
        iframeWindow.scrollTo(0, newPosition);

        if (progress < 1) {
            requestAnimationFrame(scroll);
        } else {
            // 滚动完成后执行回调
            callback();
        }
    }
    requestAnimationFrame(scroll);
}

function util_currentpage_scrollToBottomWithCallback(callback) {
    var start = window.pageYOffset; // 当前滚动位置
    var end = document.documentElement.scrollHeight - window.innerHeight; // 滚动到底部

    var duration = 8000; // 8 秒
    var startTime = null;

    function scroll(time) {
        if (!startTime) {
            startTime = time;
        }
        var progress = (time - startTime) / duration;
        if (progress > 1) {
            progress = 1;
        }
        var newPosition = start + (end - start) * progress;
        window.scrollTo(0, newPosition);

        if (progress < 1) {
            requestAnimationFrame(scroll);
        } else {
            // 滚动完成后执行回调
            callback();
        }
    }
    requestAnimationFrame(scroll);
}

function shangjia_new_tab_process_item(need_item){
    console.log('shangjia_new_tab_process_item a1');
    //$('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;'>正在采集，30秒采集一个。如果长时间未动，可以尝试刷新该页面！如遇到验证码请及时验证。</div>");
    //
    // 在新标签页中打开指定的 URL
    var message = {
        action: 'open_new_tab',
        info: '',
        need_item: need_item
    };
    send_message_to_popup(message);
    //
}

function util_get_json(url= ''){
    console.log('url:'+url);
    let r_data = '';
    $.ajax({
            url:url,
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:false,
            dataType: 'json',
            crossDomain: true,
            cache: false,
            success: function(data) {
                console.log('util_get_json:'+url);
                console.log(data);
                r_data =  data;
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
            }
        });
    return r_data;
}

function util_get_ajax_html(url= ''){
    console.log('util_get_ajax_html url:'+url);
    let r_data = '';
    $.ajax({
            url:url,
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:false,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                r_data =  data;
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('util_get_ajax_html遇到反爬');
                console.log( jqXHR, textStatus, errorThrown );
            }
        });
    return r_data;
}

function shangjia_get_subskus(_dom,_shangjia_goodsId='',
                              specs_key1_name='',
                              _specs_key1_value = '',
                              specs_key2_name=''){
    //
    let _shangjia_variants_skus_cucao = [];
    _dom.find("#variation_size_name select[name='dropdown_selected_size_name'] option").each(function (){
        //
        let _option_val = $(this).val();
        if(_option_val != '-1'){
            //
            let specs_key2_value = $(this).text();
            specs_key2_value = specs_key2_value.trim();
            //
            let _subsku = _shangjia_goodsId+'-'+_specs_key1_value+'-'+specs_key2_value;
            //
            let _product_price = _dom.find('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
            let _product_old_price = _dom.find('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
            if(_product_price){
                _product_price = _product_price.trim();
                _product_price = _product_price.replace('$','');
            }
            if(_product_old_price){
                _product_old_price = _product_old_price.trim();
                _product_old_price = _product_old_price.replace('$','');
            }
            //
            let _stockQuantity = '';
            let _quantity_text = _dom.find('#availabilityInsideBuyBox_feature_div:eq(0) #availability span').text();
            _quantity_text = _quantity_text.trim();
            let _quantity_text_lower = _quantity_text.toLowerCase();
            if(_quantity_text_lower == 'in stock' || _quantity_text_lower.indexOf('in stock') !=-1
                            || _quantity_text == '现在有货。'
                            || _quantity_text_lower.indexOf('ships') !=-1
                            || _quantity_text_lower.indexOf('ship') !=-1
            ){
                //
                //
            }else{
                //Only 8 left in stock - order soon.
                // 库存中仅剩 1 件 - 欲购从速。
                _quantity_text = _quantity_text.replace('Only','').replace('left in stock - order soon.','')
                            .replace('库存中仅剩','').replace('件 - 欲购从速。','').replace('left in stock (more on the way).','');
                _quantity_text = _quantity_text.trim();
                //
                if(_quantity_text_lower.indexOf('out of stock') !=-1){
                    _stockQuantity = 0;
                }
                //
            }
            //
            _shangjia_variants_skus_cucao.push({
                'subsku': _subsku, //自定义变体带属性SKU
                'normalPriceStr': _product_price, //特价
                'normalLinePriceStr': _product_old_price, //原价
                'img':'',
                'gallery_imgs':[],
                'video_url':'',
                'specs_key1_name':_specs_key1_value!=''?specs_key1_name:'',
                'specs_key1_value':_specs_key1_value,
                'specs_key2_name':specs_key2_name,
                'specs_key2_value':specs_key2_value,
                'specs_key3_name':'',
                'specs_key3_value':'',
                'specs_key4_name':'',
                'specs_key4_value':'',
                'stockQuantity': _stockQuantity,
                'skuId': '' //原变体sku
            });
            //
        }
    });
    //ul li形式
    _dom.find("#variation_size_name ul li").each(function (){
        //
        if(1){
            //
            let specs_key2_value = $(this).find('.twisterTextDiv').text();
            specs_key2_value = specs_key2_value.trim();
            //
            let _subsku = _shangjia_goodsId+'-'+_specs_key1_value+'-'+specs_key2_value;
            //
            let _product_price = _dom.find('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
            let _product_old_price = _dom.find('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
            if(_product_price){
                _product_price = _product_price.trim();
                _product_price = _product_price.replace('$','');
            }
            if(_product_old_price){
                _product_old_price = _product_old_price.trim();
                _product_old_price = _product_old_price.replace('$','');
            }
            //
            let _stockQuantity = '';
            let _quantity_text = _dom.find('#availabilityInsideBuyBox_feature_div:eq(0) #availability span').text();
            _quantity_text = _quantity_text.trim();
            let _quantity_text_lower = _quantity_text.toLowerCase();
            if(_quantity_text_lower == 'in stock' || _quantity_text_lower.indexOf('in stock') !=-1
                            || _quantity_text == '现在有货。'
                            || _quantity_text_lower.indexOf('ships') !=-1
                            || _quantity_text_lower.indexOf('ship') !=-1
            ){
                //
                //
            }else{
                //Only 8 left in stock - order soon.
                // 库存中仅剩 1 件 - 欲购从速。
                _quantity_text = _quantity_text.replace('Only','').replace('left in stock - order soon.','')
                            .replace('库存中仅剩','').replace('件 - 欲购从速。','').replace('left in stock (more on the way).','');
                _quantity_text = _quantity_text.trim();
                //
                if(_quantity_text_lower.indexOf('out of stock') !=-1){
                    _stockQuantity = 0;
                }
                //
            }
            //
            _shangjia_variants_skus_cucao.push({
                'subsku': _subsku, //自定义变体带属性SKU
                'normalPriceStr': _product_price, //特价
                'normalLinePriceStr': _product_old_price, //原价
                'img':'',
                'gallery_imgs':[],
                'video_url':'',
                'specs_key1_name':_specs_key1_value!=''?specs_key1_name:'',
                'specs_key1_value':_specs_key1_value,
                'specs_key2_name':specs_key2_name,
                'specs_key2_value':specs_key2_value,
                'specs_key3_name':'',
                'specs_key3_value':'',
                'specs_key4_name':'',
                'specs_key4_value':'',
                'stockQuantity': _stockQuantity,
                'skuId': '' //原变体sku
            });
            //
        }
    });

    //console.log('_shangjia_variants_skus_cucao');
    //console.log(_shangjia_variants_skus_cucao);
    return _shangjia_variants_skus_cucao;
    //
}

function shangjia_get_subskus_ajax( current_domain,
                                    specs_key1_name='',
                                    specs_key2_name='',
                                    relation_color_asin='',
                                   _size_arr=[]){
    //
    let _shangjia_variants_skus_cucao = [];
    let subsku_url = 'https://'+current_domain+'/name/dp/'+relation_color_asin+'/?psc=1';
    let _html_data = util_get_ajax_html(subsku_url);
    if(_html_data){
        console.log('shangjia_get_subskus_ajax a1');
        let _html_dom = $(_html_data);
        let _specs_key1_value = _html_dom.find('#variation_color_name span.selection').text();
        _specs_key1_value = _specs_key1_value.trim();
        //select形式的
        if(typeof _specs_key1_value == 'undefined' || _specs_key1_value == ''){
            _specs_key1_value = _html_dom.find('#dropdown_selected_color_name').text();
            if(_specs_key1_value){
                _specs_key1_value = _specs_key1_value.trim();
            }
        }
        //
        let _original_price = '';
        let _discount_price = '';
        let _stockQuantity = '';
        let _color_image = '';
        _color_image = _html_dom.find('#variation_color_name .swatchSelect').find('img').attr('src');
        //
        let _product_price = _html_dom.find('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
        let _product_old_price = _html_dom.find('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
        if(_product_price){
            _product_price = _product_price.trim();
            _product_price = _product_price.replace('$','');
        }
        _discount_price = _product_price;
        if(_product_old_price){
            _product_old_price = _product_old_price.trim();
            _product_old_price = _product_old_price.replace('$','');
        }
        _original_price = _product_old_price;
        //
        console.log('shangjia_get_subskus_ajax a2');
        let _shangjia_gallery = util_amz_get_product_lunbo_imgs(_html_dom);
        let _img = _shangjia_gallery[0];
        //
        let _video_url = util_amz_get_product_video(_html_data);
        //
        ///let _quantity_ajax_url = "https://www.amazon.com/gp/product/ajax?&asin="+need_item['_asin']+"&quantity=1&exclusiveMerchantId=A39YJHD2QGAV1F&merchantId=A39YJHD2QGAV1F&clientId=retailwebsite&deviceType=web&showFeatures=deliveryBlock&ie=UTF8&experienceId=deliveryBlockQuantityRefreshAjaxExperience";
        let _quantity_text = _html_dom.find('#availabilityInsideBuyBox_feature_div:eq(0) #availability span').text();
        _quantity_text = _quantity_text.trim();
        let _quantity_text_lower = _quantity_text.toLowerCase();
        if(_quantity_text_lower == 'in stock' || _quantity_text_lower.indexOf('in stock') !=-1
                        || _quantity_text == '现在有货。'
                        || _quantity_text_lower.indexOf('ships') !=-1
                        || _quantity_text_lower.indexOf('ship') !=-1
        ){
            //
            //
        }else{
            //Only 8 left in stock - order soon.
            // 库存中仅剩 1 件 - 欲购从速。
            _quantity_text = _quantity_text.replace('Only','').replace('left in stock - order soon.','')
                        .replace('库存中仅剩','').replace('件 - 欲购从速。','').replace('left in stock (more on the way).','');
            _quantity_text = _quantity_text.trim();
            //
            if(_quantity_text_lower.indexOf('out of stock') !=-1){
                _stockQuantity = 0;
            }
            //
        }
        //
        if(_size_arr.length>0){
            console.log('shangjia_get_subskus_ajax a3');
           for(let _s=0;_s<_size_arr.length;_s++){
                //
                let specs_key2_value = _size_arr[_s];
                //
                let _subsku = relation_color_asin+'-'+_specs_key1_value+'-'+specs_key2_value;
                _shangjia_variants_skus_cucao.push({
                        'subsku': _subsku, //自定义变体带属性SKU
                        'normalPriceStr': _discount_price, //特价
                        'normalLinePriceStr': _original_price, //原价
                        'color_image':_color_image,
                        'img':_img,
                        'gallery_imgs':_shangjia_gallery,
                        'video_url':_video_url,
                        'specs_key1_name':specs_key1_name,
                        'specs_key1_value':_specs_key1_value,
                        'specs_key2_name':specs_key2_name,
                        'specs_key2_value':specs_key2_value,
                        'specs_key3_name':'',
                        'specs_key3_value':'',
                        'specs_key4_name':'',
                        'specs_key4_value':'',
                        'stockQuantity': _stockQuantity,
                        'skuId': '' //原变体sku
                });
            }
        }else{
            //
            let _subsku = relation_color_asin+'-'+_specs_key1_value;

            _shangjia_variants_skus_cucao.push({
                'subsku': _subsku, //自定义变体带属性SKU
                'normalPriceStr': _discount_price, //特价
                'normalLinePriceStr': _original_price, //原价
                'color_image':_color_image,
                'img':_img,
                'gallery_imgs':_shangjia_gallery,
                'video_url':_video_url,
                'specs_key1_name':specs_key1_name,
                'specs_key1_value':_specs_key1_value,
                'specs_key2_name':specs_key2_name,
                'specs_key2_value':'',
                'specs_key3_name':'',
                'specs_key3_value':'',
                'specs_key4_name':'',
                'specs_key4_value':'',
                'stockQuantity': _stockQuantity,
                'skuId': '' //原变体sku
            });
            //
        }
    }else{
        console.log('shangjia_get_subskus_ajax a3');
    }
    console.log('_shangjia_variants_skus_cucao');
    console.log(_shangjia_variants_skus_cucao);
    return _shangjia_variants_skus_cucao;
    //
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.__GLOBAL_DADA=') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_getscript_goodsDetailV3SsrData_content_old(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('goodsDetailV3SsrData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_getscript_goodsDetailV3SsrData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.gbRawData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function shangjia_getsubsku_img(skuPropValues=[], skuprop=''){
    let _img = '';
    for(let i=0;i<skuPropValues.length;i++){
        if(skuPropValues[i]['name'] == skuprop){
            _img = skuPropValues[i]['imageUrl'];
            break;
        }
    }
    return _img;
}

function shangjia_new_tab_process_item_step2(){
    let currentUrl = window.location.href;
    if(currentUrl.indexOf('_shangjia_about_contact_and_basic_info_link_key') != -1) {
        let queryParams = util_getCurrentUrlQueryStringParams();
        console.log('queryParams');
        console.log(queryParams);
        let _shangjia_about_contact_and_basic_info_link_key = queryParams['_shangjia_about_contact_and_basic_info_link_key'];
        let _request_type = queryParams['_request_type'];
        //
        /**
         *
         //
         '_shangjia_goodsId':'', //sku
         '_shangjia_variants_skus': [], //数组
         '_shangjia_goodsName': '',
         '_shangjia_goodsProperty':'',//description,deschtml
         '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
         '_shangjia_hdThumbUrl': '',//主图
         '_shangjia_gallery':[], //图片列表
         '_shangjia_productDetailFlatList':[],//details imgs
         '_shangjia_category':'',//brumb
         '_shangjia_VideoUrl':'', //video
         //
         _shangjia_variants_skus
         {
             'subsku': _skus[_i]['goodsId']+subsku_specs, //自定义变体带属性SKU
             'normalPriceStr': _skus[_i]['normalPriceStr'], //特价
             'normalLinePriceStr': _skus[_i]['normalLinePriceStr'], //原价
             'img':_skus[_i]['specShowImageUrl'],
             'specs_key1_name':specs_key1_name,
             'specs_key1_value':specs_key1_value,
             'specs_key2_name':specs_key2_name,
             'specs_key2_value':specs_key2_value,
             'specs_key3_name':specs_key3_name,
             'specs_key3_value':specs_key3_value,
             'specs_key4_name':specs_key4_name,
             'specs_key4_value':specs_key4_value,
             'stockQuantity': _skus[_i]['stockQuantity'],
             'skuId': _skus[_i]['skuId'] //原变体sku
             }
         */

        let _shangjia_goodsName = $('.product-intro__head-name').text();
        if(_shangjia_goodsName){
            //
             let _goodsDetailV3SsrData = util_getscript_goodsDetailV3SsrData_content($('html').html());
             let _goodsDetailV3SsrData_json = {};
             if(_goodsDetailV3SsrData) {
                 _goodsDetailV3SsrData_arr = _goodsDetailV3SsrData.split('//物流运费展示');
                 if (_goodsDetailV3SsrData_arr.length == 2) {
                     _goodsDetailV3SsrData = _goodsDetailV3SsrData_arr[0];
                     //_goodsDetailV3SsrData = _goodsDetailV3SsrData.replace('window.goodsDetailV3SsrData =', '');
                     _goodsDetailV3SsrData = _goodsDetailV3SsrData.replace('window.gbRawData =', '');
                     _goodsDetailV3SsrData = _goodsDetailV3SsrData.trim();
                     console.log('_goodsDetailV3SsrData');
                     console.log(_goodsDetailV3SsrData);
                     _goodsDetailV3SsrData_json = JSON.parse(_goodsDetailV3SsrData);
                     console.log('_goodsDetailV3SsrData_json');
                     console.log(_goodsDetailV3SsrData_json);
                     //
                    let _subsku_is_all_request = true;
                    let shangjia_info = {};
                    let _shangjia_goodsId = $('.product-intro__head-sku').text();
                    _shangjia_goodsId =_shangjia_goodsId.replace('SKU:','');
                    _shangjia_goodsId = _shangjia_goodsId.trim();
                    shangjia_info['_shangjia_goodsId'] = _shangjia_goodsId;
                    //
                    _shangjia_goodsName = _shangjia_goodsName.trim();
                    shangjia_info['_shangjia_goodsName'] = _shangjia_goodsName;
                    //
                    let _original_price = '';
                     _original_price = $('.product-intro__head-mainprice .original span').text();
                    if(_original_price == '' || typeof _original_price == 'undefined'){
                        _original_price = $('.product-intro__head-mainprice .del-price').text();
                    }
                    //
                    let _discount_price = $('.product-intro__head-mainprice .discount span').text();
                    if(_discount_price=='' || typeof _discount_price == 'undefined'){
                        _discount_price = _original_price;
                    }
                    //
                     if(_discount_price =='' && _original_price ==''){
                         _original_price = $('.price-estimated-percent__retail span.price-num').text();
                         _discount_price = $('.price-estimated-percent__price').text();
                     }
                    //
                    let _shangjia_minOnSalePriceStr = _discount_price;
                    _shangjia_minOnSalePriceStr = _shangjia_minOnSalePriceStr.replace('¥','');
                    _shangjia_minOnSalePriceStr = _shangjia_minOnSalePriceStr.trim();
                    shangjia_info['_shangjia_minOnSalePriceStr'] = _shangjia_minOnSalePriceStr;
                    shangjia_info['_shangjia_minOriginPriceStr'] = _original_price;
                    //
                    shangjia_info['_shangjia_desc'] = "<div class='product-intro__description'>"+$('.product-intro__description-table').html()+"</div>";
                    let  _product_intro__sizeguide = $('.product-intro__sizeguide .product-intro__sizeguide-panel').html();
                    if(typeof _product_intro__sizeguide == 'undefined'){
                        _product_intro__sizeguide = '';
                    }else{
                        _product_intro__sizeguide = "<div class='product-intro__sizeguide'>"+_product_intro__sizeguide+"</div>";
                    }
                    shangjia_info['_product_intro__sizeguide'] = _product_intro__sizeguide;
                    //
                    let _shangjia_goodsProperty = "";
                    shangjia_info['_shangjia_goodsProperty'] = _shangjia_goodsProperty;
                    //
                    let _shangjia_gallery = [];
                    $('.product-intro__gallery .product-intro__thumbs-item').each(function (){
                        let _img = $(this).find('img').attr('data-src');
                        if(_img.indexOf('_thumbnail') !=-1){
                            let _img_arr = _img.split('_thumbnail');
                            let _img_wei = _img_arr[1];
                            let _img_wei_arr = _img_wei.split('.');
                            _img = _img_arr[0]+'.'+_img_wei_arr[1];
                        }
                        if(_img.indexOf('http') == -1){
                            _img = _img.replace('//','http://');
                        }
                        _shangjia_gallery.push(_img);
                    });
                    let _shangjia_hdThumbUrl = _shangjia_gallery[0];
                    shangjia_info['_shangjia_hdThumbUrl'] = _shangjia_hdThumbUrl;
                    //
                    shangjia_info['_shangjia_productDetailFlatList'] = [];
                    let _shangjia_VideoUrl = _goodsDetailV3SsrData_json['productIntroData']['goods_imgs']['video_url'];
                    shangjia_info['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                    //子sku
                    let specs_key1_name = '';
                    let specs_key2_name = '';
                    specs_key1_name = $('.product-intro__select-box .product-intro__color .title').text();
                    if(typeof specs_key1_name != "undefined"){
                        specs_key1_name = specs_key1_name.replace(':','');
                    }else{
                        specs_key1_name = '';
                    }
                    //
                    specs_key2_name = $('.product-intro__select-box .product-intro__size .product-intro__size-title').attr('aria-label');
                    if(typeof specs_key2_name == 'undefined'){
                        specs_key2_name = '';
                    }
                    //如果color存在且大于2个，则不采集
                    let specs_key1_name_values_num = 0;
                    $('.product-intro__color_choose .product-intro__color-radio').each(function (){
                            specs_key1_name_values_num +=1;
                        });
                     $('.product-intro__color_choose .product-intro__color-block').each(function (){
                            specs_key1_name_values_num +=1;
                        });

                     let _shangjia_variants_skus = [];
                     if(specs_key1_name_values_num > 1){
                         _shangjia_gallery = [];
                         let _size_arr = [];
                         $('.product-intro__size-choose .product-intro__size-radio-spopover').each(function (){
                              let specs_key2_value = $(this).find('.product-intro__size-radio').attr('aria-label');
                              _size_arr.push(specs_key2_value);
                         });
                         let relation_color_arr = _goodsDetailV3SsrData_json['productIntroData']['relation_color'];
                         //把自己加上去
                         relation_color_arr.unshift({
                             'goods_id': _goodsDetailV3SsrData_json['productIntroData']['detail']['goods_id']
                         })
                         //
                         for(let _r=0;_r<relation_color_arr.length;_r++){
                            let _shangjia_variants_skus_cucao = shangjia_get_subskus_ajax(
                                shangjia_info['_shangjia_goodsId'],
                                specs_key1_name,
                                specs_key2_name,
                                relation_color_arr[_r],
                                _size_arr);
                            if(_shangjia_variants_skus_cucao.length ==0){
                                _subsku_is_all_request = false;
                                break;
                            }
                            for(let _c=0;_c<_shangjia_variants_skus_cucao.length;_c++){
                                //
                                if(_c==0){
                                    //同一个颜色有多个尺寸，只取第一个即可
                                    let _gallery_imgs = _shangjia_variants_skus_cucao[_c]['gallery_imgs'];
                                    for(let _g=0;_g<_gallery_imgs.length;_g++){
                                        _shangjia_gallery.push(_gallery_imgs[_g]);
                                    }
                                }
                                //
                                _shangjia_variants_skus.push(_shangjia_variants_skus_cucao[_c]);
                            }
                         }
                        //
                     }else{
                         //
                         if(specs_key2_name){ //有尺寸
                            let _shangjia_variants_skus_cucao = shangjia_get_subskus(
                                shangjia_info['_shangjia_goodsId'],
                                specs_key1_name,
                                '',
                                specs_key2_name);
                            for(let _c=0;_c<_shangjia_variants_skus_cucao.length;_c++){
                                _shangjia_variants_skus.push(_shangjia_variants_skus_cucao[_c]);
                            }
                        }else{
                             //无尺寸,无属性
                             _shangjia_variants_skus.push({
                                'subsku': shangjia_info['_shangjia_goodsId']+'Z', //
                                'normalPriceStr': _discount_price, //特价
                                'normalLinePriceStr': _original_price, //原价
                                'img':'',
                                'gallery_imgs':[],
                                'video_url':_shangjia_VideoUrl,
                                'specs_key1_name':'',
                                'specs_key1_value':'',
                                'specs_key2_name':'',
                                'specs_key2_value':'',
                                'specs_key3_name':'',
                                'specs_key3_value':'',
                                'specs_key4_name':'',
                                'specs_key4_value':'',
                                'stockQuantity': _goodsDetailV3SsrData_json['productIntroData']['detail']['stock'],
                                'skuId': '' //原变体sku
                             });
                         }
                         //
                     }
                    //
                    shangjia_info['_shangjia_variants_skus'] = _shangjia_variants_skus;
                    shangjia_info['_shangjia_gallery'] = _shangjia_gallery;
                    //
                    shangjia_info['_shangjia_sold'] = 0;
                    let _shangjia_review_num = $('.product-intro__head-reviews-text').attr('data-review-num');
                    console.log('_shangjia_review_num');
                    console.log(_shangjia_review_num);
                    if(typeof _shangjia_review_num == 'undefined'){
                        _shangjia_review_num = 0;
                    }else{
                        _shangjia_review_num = parseInt(_shangjia_review_num);
                    }
                    shangjia_info['_shangjia_reivew_num'] = _shangjia_review_num;
                    shangjia_info['_shangjia_about_contact_and_basic_info_link_key'] = _shangjia_about_contact_and_basic_info_link_key;
                    console.log('shangjia_info');
                    console.log(shangjia_info);
                    //
                    // 在新标签页中打开指定的 URL
                    if(_subsku_is_all_request){
                       //
                        var message = {
                            action: 'shangjia_new_tab_process_item_step2_complete',
                            info: '',
                            shangjia_info:shangjia_info
                        };
                        console.log('message');
                        console.log(message);
                        chrome.runtime.sendMessage(message,(msg)=>{
                            console.log('答复',msg)
                            //let msgobj = JSON.parse(msg);
                            //
                            var message = {
                                action: 'closeTab',
                                info: ''
                            };
                            send_message_to_popup(message);
                            //
                        })
                        //
                    }
                 }
             }
        }else{
            let _info__error = $('.info__error-tips').html();
            if(_info__error){
                let shangjia_info ={};
                shangjia_info['_shangjia_about_contact_and_basic_info_link_key'] = _shangjia_about_contact_and_basic_info_link_key;
                shangjia_info['_shangjia_reivew_num'] = 0;
                shangjia_info['_shangjia_variants_skus'] = [];
                shangjia_info['_shangjia_gallery'] = [];
                shangjia_info['_shangjia_sold'] = 0;
                shangjia_info['_shangjia_hdThumbUrl']  = '';
                shangjia_info['_shangjia_productDetailFlatList'] = [];
                shangjia_info['_shangjia_VideoUrl'] = '';
                shangjia_info['_shangjia_goodsProperty'] = '';
                shangjia_info['_shangjia_desc'] = '';
                shangjia_info['_product_intro__sizeguide'] = '';
                shangjia_info['_shangjia_minOnSalePriceStr'] = 0;
                shangjia_info['_shangjia_minOriginPriceStr'] = 0;
                shangjia_info['_shangjia_goodsId'] = '';
                shangjia_info['_shangjia_goodsName'] = '';
                shangjia_info['_shangjia_category'] = '';

                var message = {
                    action: 'shangjia_new_tab_process_item_step2_complete',
                    info: '',
                    shangjia_info:shangjia_info
                };
                console.log('message');
                console.log(message);
                chrome.runtime.sendMessage(message,(msg)=>{
                    console.log('答复',msg)
                    //let msgobj = JSON.parse(msg);
                    //
                    var message = {
                        action: 'closeTab',
                        info: ''
                    };
                    send_message_to_popup(message);
                    //
                })
            }
        }
    }
}

//打开指定采集页面开始采集
function process_caiji_taobao_item(){
    console.log('process_caiji_taobao_item s');
    let current_url = window.location.href;
    if(current_url && current_url.indexOf('7455077') != -1) {
        $('.c-outermost-ctn').remove();
        $('.c-header').hide();
        $('#goods-detail-v3').hide();
        $('.c-footer ').hide();
        $('#gycharm-custom-msg').remove();
         var message = {
             action: 'caiji_item_get_taobao',
             info: ''
         };
         chrome.runtime.sendMessage(message, (msg) => {
             console.log('process_caiji_taobao_item 答复', msg)
             let msgobj = JSON.parse(msg);
             let need_item = msgobj['need_item'];
             //console.log(msgobj['need_item']);
             if (need_item) {
                 //
                 $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>正在采集:"+need_item['_shangjia_name']+','+need_item['_shangjia_about_contact_and_basic_info_link']+"</div>");
                 //shangjia_insert_iframe_and_get_content_taobao(need_item);
                 shangjia_new_tab_process_item(need_item);
             }else{
                 //
                 let status = msgobj['status'];
                 status = parseInt(status);
                 if(status == 1){
                     $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>后台采集已暂停，可以在插件工具里开启后台采集</div>");
                    //
                 }else if(status == 3){
                     $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>目前已有商品在采集，稍等</div>");
                    //
                 }else if(status == 2){
                     console.log('f2');
                     $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>所有商品已采集完成</div>");
                    //
                 }
             }
         })
        //
    }
}

function xintiao(){
    process_caiji_taobao_item();
}
//xintiao();
//setInterval(xintiao, 40000);

//
function add_product_to_plugin_Button(){
    //
    let current_url = window.location.href;
    console.log('add_product_to_plugin_Button aa11');

    $('button.add_product_to_plugin_Button').remove();
     // 创建一个按钮元素
    if (current_url.indexOf('pdsearch') != -1 || current_url.indexOf('-sc-') != -1 || current_url.indexOf('-c-') != -1 || current_url.indexOf('store/home') != -1) {
        var add_product_to_plugin_Button = $("<button>", {
            text: '批量采集', // 按钮文本
            class:'add_product_to_plugin_Button',
            style: "display: block;\n" +
                    "    z-index:9999;\n" +
                    "    background: #fb7701;\n" +
                    "    border: 0;\n" +
                    "    width: 160px;\n" +
                    "    height: 46px;\n" +
                    "    line-height: 46px;\n" +
                    "    color: #FFF;\n" +
                    "    font-weight: bold;\n" +
                    "    cursor:pointer;\n" +
                    "    border-radius: 22px;",
            click: function() {
                //
                $('.gycharm-tips').remove();
                shangjia_search_caiji();
                //
            } // 点击按钮时执行的函数
        });
        $('.sui-pagination').append(add_product_to_plugin_Button);
    }
}
//

function downloadIamge(imgsrc, name){//下载图片地址和图片名
    let image = new Image();
    // 解决跨域 Canvas 污染问题
    image.setAttribute("crossOrigin", "anonymous");
    image.onload = function() {
        let canvas = document.createElement("canvas");
        canvas.width = image.width;
        canvas.height = image.height;
        let context = canvas.getContext("2d");
        context.drawImage(image, 0, 0, image.width, image.height);
        let url = canvas.toDataURL("image/jpeg"); //得到图片的base64编码数据
        let a = document.createElement("a"); // 生成一个a元素
        let event = new MouseEvent("click"); // 创建一个单击事件
        a.download = name || "photo"; // 设置图片名称
        a.href = url; // 将生成的URL设置为a.href属性
        a.dispatchEvent(event); // 触发a的单击事件
    }
    image.src = imgsrc;
}

function util_amz_get_asin(url = ''){
    let url_arr = url.split('dp/');
    if(url_arr.length>=2){
        let url_dp_str = url_arr[1];
        let url_dp_arr = url_dp_str.split('/');
        let dp =  url_dp_arr[0];
        if(dp.length>=6){
            return dp;
        }
    }
    return '';
}
//
function amz_product_lunbo_imgs_download(){
   let _leftColHtml =  $('#leftCol').html();
   let _amz_script = util_amz_getscript_pageData_content(_leftColHtml);
   //console.log('_amz_script');
   //console.log(_amz_script);
   let _amz_script_tmp_arr = _amz_script.split("var data =");
   let _amz_script_tmp_str = _amz_script_tmp_arr[1];
   let _amz_script_tmp_str_arr = _amz_script_tmp_str.split('A.trigger');
   let _amz_script_imgs_str = _amz_script_tmp_str_arr[0];
   _amz_script_imgs_str = _amz_script_imgs_str.trim();
   _amz_script_imgs_str = _amz_script_imgs_str.slice(0,-1);
   //
    let _amz_script_imgs_tmp_arr  = _amz_script_imgs_str.split("'colorImages':");
    //
    let _amz_script_imgs_temp2 = _amz_script_imgs_tmp_arr[1];
    let _amz_script_imgs_temp2_str = _amz_script_imgs_temp2.split("'colorToAsin'");
    let _amz_script_imgs = _amz_script_imgs_temp2_str[0];
    _amz_script_imgs = _amz_script_imgs.trim();
    _amz_script_imgs = _amz_script_imgs.slice(0,-1);
    _amz_script_imgs = _amz_script_imgs.replace("{ 'initial':","");
    _amz_script_imgs = _amz_script_imgs.slice(0,-1);
    let _amz_script_imgs_arr = JSON.parse(_amz_script_imgs);
    console.log('_amz_script_imgs_arr');
    console.log(_amz_script_imgs_arr);
    //
    let current_url = window.location.href;
    let asin = util_amz_get_asin(current_url);
    let _sort = 1;
    for(let i=0;i<_amz_script_imgs_arr.length;i++){
        let _img = _amz_script_imgs_arr[i]['large'];
        if(_img){
            let _img_src = _img;
            let _imgarr = _img.split('/');
            let _img_name = _imgarr[_imgarr.length-1];
            let _img_name_arr = _img_name.split('.');
            _img_name = _img_name_arr[0];
            _img_name = 'amazon_'+asin+'_'+_sort+'_'+_img_name;
            //
            downloadIamge(_img_src,_img_name);
            _sort++;
        }
    }
    //
}

function amz_product_detail_imgs_download(){
    let current_url = window.location.href;
    let asin = util_amz_get_asin(current_url);
    let _sort = 1;
    $('#aplus_feature_div img').each(function (){
        let _img = $(this).attr('data-src');
        let _img_src = _img;
        let _imgarr = _img.split('/');
        let _img_name = _imgarr[_imgarr.length-1];
        let _img_name_arr = _img_name.split('.');
        _img_name = _img_name_arr[0];
        _img_name = 'amazon_'+asin+'_'+_sort+'_detail_'+_img_name;
        //
        downloadIamge(_img_src,_img_name);
        _sort++;
    });
}

function amz_add_download_btn(){
    let current_url = window.location.href;
    if(current_url.indexOf('dp/')!=-1){
        var btn_product_lunbo_imgs = $("<button>", {
            text: '下载轮播主图', // 按钮文本
            style: "display: block;\n" +
                "    margin-top: 10px;\n" +
                "    top: 460px;\n" +
                "    right: 0;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    border: 0;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               amz_product_lunbo_imgs_download();
            }
        });
        $('#leftCol').append(btn_product_lunbo_imgs);
        //
        var btn_product_details_imgs = $("<button>", {
            text: '下载描述图片', // 按钮文本
            style: "display: block;\n" +
                "    margin-top: 10px;\n" +
                "    right: 0;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    border: 0;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    margin-top: 10px;\n" +
                "    border-radius: 22px;",
            click: function() {
               amz_product_detail_imgs_download();
            }
        });
        $('#leftCol').append(btn_product_details_imgs);
        //
    }
}

//
//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}
// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
})
//

//send message to pop
function send_message_to_background(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}